package WebFlow.Charon;

import org.omg.CORBA.*;
import WebFlow.*;
import WebFlow.event.*;
import java.io.*;
import java.net.*;
import java.util.*;

public class MyCharon {

 public ORB orb;
 public String IorURL;
 public WebFlowContext master = null;
 public CharonServer charon;
 org.omg.CORBA.Object och;
 String TargetServer;
 ServerSocket server;
 PrintWriter out;
 BufferedOutputStream bos;
 String RequestType, RequestFile, RequestURL;
 boolean binary;
 byte[] buf;

 public MyCharon(String ior, String TargetServer) {
 
 this.TargetServer = TargetServer;
 connect(ior);
 try {
   server = new ServerSocket(8085);     
   while (true) {
       /* listen to requests from the local web browser */
     System.out.println("waiting for requests...");
     Socket socket = server.accept();
     InetAddress host=socket.getInetAddress();
     String hostaddress = host.getHostAddress();
     if(!hostaddress.equals("127.0.0.1")) {
       System.out.println(" ===================== ");
       System.out.println(" Warning: unauthorized access from "+hostaddress);
       System.exit(0);
     }
 
     /* read and parse request */

     BufferedReader in = 
     new BufferedReader(new InputStreamReader(socket.getInputStream()));
     String str = in.readLine();
     /* the first line should be the request */
     StringTokenizer st = new StringTokenizer(str);
     RequestType = st.nextToken();
     RequestFile = st.nextToken();
     RequestURL = TargetServer+RequestFile;
     System.out.println("request type: "+RequestType);
     System.out.println("request  url: "+RequestURL);
     binary=true;  
     if(RequestFile.endsWith(".html")) binary=false;
     if(RequestFile.endsWith(".HTML")) binary=false;
     if(RequestFile.endsWith(".htm")) binary=false;
     if(RequestFile.endsWith(".HTM")) binary=false;
     if(RequestFile.endsWith(".txt")) binary=false;
     if(RequestFile.endsWith(".TXT")) binary=false;
     if(RequestFile.indexOf("servlet")>-1) binary=false;
     System.out.println("binary set to "+binary);

     /* read the rquest to the end */
     while (!str.equals("")) {
     try {
           str = in.readLine();
           System.out.println(str);
     } catch (java.lang.NullPointerException e) {}
    }

     /* open output stream to browser */

     try {
       OutputStream os=socket.getOutputStream();
       if(binary) {bos = new BufferedOutputStream(os);}
       else {out = new PrintWriter(os,true);}
       // out = new PrintWriter(os,true);
     } catch (Exception e) {
         System.out.println("cannot open output stream...");
         System.out.println(e);
     }

     /* make request on bahalf of the browser */

     if(charon.connect(RequestURL)){
       try {
         if(binary) {
           buf = charon.getBinaryBlock();
           while(buf.length>1) {
             bos.write(buf,0,buf.length);
             bos.flush();
             buf = charon.getBinaryBlock();
           } 
         }
         else {    
           String nextLine = charon.getBlock();
           while(!nextLine.equals("EOF")) {
             out.println(nextLine);
             nextLine = charon.getBlock();
	   }
         }
           charon.closeConnection();
           socket.close();
       } catch (Exception e) {
           System.out.println("IO error writting back to browser");
           System.out.println(e);
       }
     }
     else {
       System.out.println("cannot open URL: "+RequestURL);
     } 

   }
 } catch (IOException e)
   {System.out.println("Conection not established with server "+e);
   }
   master.removeModule(och);
 }

  public void connect(String IorURL) {
    initializeORB(IorURL);
    master = getMasterServer(IorURL);
    if(master==null) {
      System.out.println("Cannot connect to the master server");
    }
    else {
	/* add Charon server */

        och = master.addNewModule("Charon");
        charon = CharonServerHelper.narrow(och);
        charon.test();
    }
  }


  public void initializeORB(String IorURL) { 
   Properties props = System.getProperties();
   props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
   props.put("org.omg.CORBA.ORBSingletonClass", "com.ooc.CORBA.ORBSingleton");
   System.setProperties(props);
   String[] args = new String[1];
   args[0]=IorURL;
   orb = ORB.init(args, props);
  }  

  public WebFlowContext getMasterServer(String IorURL){
    WebFlowContext ws = null;
    try {
      String masterIOR = getIORFromURL(IorURL);
      org.omg.CORBA.Object o = orb.string_to_object(masterIOR);
      ws = WebFlowContextHelper.narrow(o);
    }
    catch (Exception e) {System.out.println("getMasterServer: "+e);}
    return ws;
  }

  public String getIORFromURL(String urlString){
    String masterServerIOR="";
    String thisLine=null;
      try {
        URL u = new URL(urlString);
        try {
          DataInputStream theHTML = new DataInputStream(u.openStream());
          try {
            while ((thisLine = theHTML.readLine()) != null) {
		  masterServerIOR += thisLine;
            } 
          } 
          catch (Exception e) {
            System.out.println("getIORfromURL:"+e);
          }
        } 
        catch (Exception e) {
          System.out.println("getIORfromURL:"+e);
        }

      } 
      catch (MalformedURLException e) {
        System.out.println("getIORfromURL:"+urlString + " is not a parseable URL");
        System.out.println("getIORfromURL:"+e);
      }
    return masterServerIOR;
  }
}



