#!/usr/local/bin/perl

## Primitive parser for Gaussian output.
##
## Produces ordered pairs of points for plotting 
## orbital energies via java graphing applet.
##

##
## Name of input data file
##

$dataFile = $ARGV[0];

##
## Name of output HTML source
##

$htmlFile = $ARGV[1];

##
## Name of output data file
##

$outFile = $ARGV[2];

##
## Open files and parse input file for energy values
##

open (IN, "$dataFile") || die ("Can't open $dataFile: $!\n");
open (OUT, ">$outFile") || die ("Can't open $outFile: $!\n");

while (<IN>) {

      if (/\s+occ/) {
	@tmp1 = split(' ', $_);
	next;
      }
      if (/\s+virt/) {
	@tmp2 = split(' ', $_);
	last;
      }
}


push(@tmp1, $tmp2[4]);
push(@tmp1, $tmp2[5]);

for ($i = 0; $i < scalar(@tmp1) - 4; $i++) {
   $energies[$i] = $tmp1[$i + 4];
}

for ($i = 0; $i < scalar(@energies); $i++) {
  printf OUT "%d %9.5f\n", $i + 1, $energies[$i];
}
close(OUT);
close(IN);

##
## Open HTML file and print out HTML source
##

open (APPLET, ">$htmlFile") ||
    die ("Can't open $htmlFile: $!\n");

print  APPLET <<"end_tag";
<HTML>
<HEAD>
<TITLE>Gaussian Orbital Energies</TITLE>
</HEAD>

<BODY>
<DIV ALIGN=CENTER>
   <APPLET CODE="GraphIt.class" CODEBASE="/Analysis/" WIDTH=600 HEIGHT=400>
      <PARAM NAME="TITLE" VALUE="Gaussian Molecular Orbital Energies">
      <PARAM NAME="XTITLE" VALUE="Orbital Number">
      <PARAM NAME="YTITLE" VALUE="Energy (Ry)">
      <PARAM NAME="DATA" VALUE="$outFile">
   </APPLET>
</DIV>
<BR>
<BR>
<BR>
<BR>
<BR>
</BODY>
</HTML>
end_tag
