#!/usr/local/bin/perl

## Primitive parser for G94 output.
##
## Produces ordered pairs of points for plotting 
## energy versus optimization run number via
## java graphing applet.

##
## Name of input data file
##

$dataFile = $ARGV[0];

##
## Name of output HTML file
##

$htmlFile = $ARGV[1];

##
## Name of output data file 
##

$outFile = $ARGV[2];

##
## Open files and parse input file for energy values
##

open (IN, "$dataFile") || die ("Can't open $dataFile: $!\n");
open (OUT, ">$outFile") || die ("Can't open $outFile: $!\n");
$SCFgaussIter = 1;
while (<IN>) {

      if (/E\(RHF\)/) {
        @tmp = split(' ', $_);
	  if ($SCFgaussIter == 1) {
	    $baseline = $tmp[4];
	  }
	$energy = $tmp[4] - $baseline;
        printf OUT "%d %9.6f\n", $SCFgaussIter, $energy;
        $SCFgaussIter++;
      }
}
close(OUT);
close(IN);

##
## Open HTML file and print out HTML source
##

open (APPLET, ">$htmlFile") ||
    die ("Can't open $htmlFile: $!\n");

print  APPLET <<"end_tag";
<HTML>
<HEAD>
<TITLE>Gaussian SCF Iteration Results</TITLE>
</HEAD>

<BODY>
<DIV ALIGN=CENTER>
   <APPLET CODE="GraphIt.class" CODEBASE="/Analysis/" WIDTH=600 HEIGHT=400>
      <PARAM NAME="TITLE" VALUE="Gaussian 98 SCF Iteration Results">
      <PARAM NAME="XTITLE" VALUE="Iteration Number">
      <PARAM NAME="YTITLE" VALUE="Energy (Ry)">
      <PARAM NAME="DATA" VALUE="$outFile">
   </APPLET>
</DIV>
<BR>
<BR>
<BR>
<BR>
<BR>
</BODY>
</HTML>
end_tag
