#!/usr/local/bin/perl

## Primitive parser for Gaussian output.
##
## Produces HTML table of Mulliken charges. 
##

##
## Name of input data file
##

$dataFile = $ARGV[0];

##
## Name of HTML output file
##

$htmlFile = $ARGV[1];

##
## Open files and parse input file for energy values
##

open (IN, "$dataFile") || die ("Can't open $dataFile: $!\n");

while (<IN>) {

      if (/\s+Total atomic charges/) {
	$mark = tell IN;
	last;
      }
}

$atomCount = 0;
seek IN, $mark, 0;
while (<IN>) {

  if (/\s+Sum/) {
    last;
  }

  if (/\s+[0-9]\n/) {
    next;
  } else {

     $atomCount++;
     @tmp = split(' ', $_);

     $number[$atomCount] = $tmp[0];
     $atom[$atomCount] = $tmp[1];
     $charge[$atomCount] = $tmp[2];
  
  }
}

close(IN);
#
###
## Open HTML file and print out HTML source
##

open (TABLE, ">$htmlFile") ||
    die ("Can't open $htmlFile: $!\n");

print  TABLE<<"end_tag";
<HTML>
<HEAD>
<TITLE>Gaussian Mulliken Charges</TITLE>
</HEAD>
<BODY>
<TABLE BORDER=1 WIDTH="70%" CELLSPACING=4 ALIGN="CENTER">
  <TR>
    <TH ALIGN="CENTER" COLSPAN=3>
      Gaussian Output:<br>
      Total Atomic Charges
    </TH>
  </TR>
  <TR>
    <TD ALIGN="CENTER">
      NUMBER
    </TD>
    <TD ALIGN="CENTER">
      ATOM
    </TD>
    <TD ALIGN="CENTER">
      CHARGE
    </TD>
  </TR>
  <TR>
    <TD ALIGN="CENTER">
      $number[1]
    </TD>
    <TD ALIGN="CENTER">
      $atom[1]
    </TD>
    <TD ALIGN="CENTER">
      $charge[1]
    </TD>
  </TR>
  <TR>
    <TD ALIGN="CENTER">
      $number[2]
    </TD>
    <TD ALIGN="CENTER">
      $atom[2]
    </TD>
    <TD ALIGN="CENTER">
      $charge[2]
    </TD>
  </TR>
  <TR>
    <TD ALIGN="CENTER">
      $number[3]
    </TD>
    <TD ALIGN="CENTER">
      $atom[3]
    </TD>
    <TD ALIGN="CENTER">
      $charge[3]
    </TD>
  </TR>
</TABLE>
</BODY>
</HTML>
end_tag
