#!/usr/local/bin/perl

## Primitive parser for GAMESS output.
##
## Produces ordered pairs of points for plotting 
## orbital energies via java graphing applet.
##

##
## Name of input data file
##

$dataFile = $ARGV[0];

##
## Name of output HTML file
##

$htmlFile = $ARGV[1];

##
## Name of output data file 
##

$outFile = $ARGV[2];

##
## Open files and parse input file for energy values
##

open (IN, "$dataFile") || die ("Can't open $dataFile: $!\n");
open (OUT, ">$outFile") || die ("Can't open $outFile: $!\n");

binmode IN;

while (<IN>) {

      if (/\s+MOLECULAR ORBITALS/) {
	$mark1 = tell IN;
	last;
      }
}

$skip1 = 0;
seek IN, $mark1, 0;
while (<IN>) {
    $scratch = $_;
    $skip1++;
    if ($skip1 == 4) {
      @energies = split(' ', $_);
    }
    if (($skip1 > 4) && ($_ eq "\n")) {
      $mark2 = tell IN;
      last;
    }
}
$skip2 = 0;
seek IN, $mark2, 0;
while (<IN>) {
  $scratch = $_;  
  $skip2++;
  if ($skip2 == 2) {
      @tmp = split(' ', $_);
      push(@energies, $tmp[0]);
      push(@energies, $tmp[1]);
      last;
  }
}

for ($i = 0; $i < scalar(@energies); $i++) {
  printf OUT "%d %9.5f\n", $i + 1, $energies[$i];
}
close(OUT);
close(IN);

##
## Open HTML file and print out HTML source
##

open (APPLET, ">$htmlFile") ||
    die ("Can't open $htmlFile: $!\n");

print  APPLET <<"end_tag";
<HTML>
<HEAD>
<TITLE>GAMESS Orbital Energies</TITLE>
</HEAD>

<BODY>
<DIV ALIGN=CENTER>
   <APPLET CODE="GraphIt.class" CODEBASE="/Analysis/" WIDTH=600 HEIGHT=400>
      <PARAM NAME="TITLE" VALUE="GAMESS Molecular Orbital Energies">
      <PARAM NAME="XTITLE" VALUE="Orbital Number">
      <PARAM NAME="YTITLE" VALUE="Energy (Ry)">
      <PARAM NAME="DATA" VALUE="$outFile">
   </APPLET>
</DIV>
<BR>
<BR>
<BR>
<BR>
<BR>
</BODY>
</HTML>
end_tag
