import java.util.*;
import java.io.*;
import java.lang.reflect.*;

// Usage: java RunParser <gamess | gaussian> <SCF | OE | MC> 
//           <input_data_file> <output_html_file> [<output_data_file>]

public class RunParser {

  private static String masterParser = "ParseCCM.pl";

  public static void main (String args[]) {
    PerlExec perlExec = new PerlExec(); 

  if (Array.getLength(args) == 5) {
    String[] fullCmd = new String[] { masterParser,
		args[0], args[1], args[2], args[3], args[4] }; 
      perlExec.runCmd(fullCmd);  
    } else {
        String[] fullCmd = new String[] { masterParser, 
		args[0], args[1], args[2], args[3] };
        perlExec.runCmd(fullCmd);
    }
  }
}

class PerlExec {
  public void runCmd(String cmd[]) {
    Process p;      //declare process object
    Runtime r;      //declare runtime object
    r = Runtime.getRuntime();  //get runtime information
    try {
      p = r.exec(cmd) ;        //execute command
      try {
        p.waitFor();           //wait for command to complete
      }
      catch(InterruptedException e) {  //handle waitFor failure
        System.out.println("ERROR: waitFor failure");
        System.exit(10);       //exit application with exit code 10
      }
    }
    catch(IOException e) {     //handle exec failure
      System.out.println("ERROR: exec failure");
      System.exit(11);         //exit application with exit code 11
    }
  }
}
