#!/usr/local/bin/perl

## Primitive parser for GAMESS output.
##
## Produces ordered pairs of points for plotting 
## energy versus optimization run number via
## java graphing applet.

##
## Name of input data file
##

$dataFile = $ARGV[0];

##
## Name of output HTML file
##

$htmlFile = $ARGV[1];

##
## Name of output data file
##

$outFile = $ARGV[2];

##
## Open files and parse input file for energy values
##

open (IN, "$dataFile") || die ("Can't open $dataFile: $!\n");
open (OUT, ">$outFile") || die ("Can't open $outFile: $!\n");

while (<IN>) {

      if (/^   [0-9]  [0-9]/) {
        @tmp = split(' ', $_);
	  if ($tmp[0] == 1) {
	    $baseline = $tmp[3];
	  }
	$SCFgamessIter = $tmp[0];
	$energy = $tmp[3] - $baseline;
	if ($tmp[4] == 0.0) {
	  last;
        }
        printf OUT "%d %9.6f\n", $SCFgamessIter, $energy;
      }
}
close(OUT);
close(IN);

##
## Open HTML file and print out HTML source
##

open (APPLET, ">$htmlFile") ||
    die ("Can't open $htmlFile: $!\n");

print  APPLET <<"end_tag";
<HTML>
<HEAD>
<TITLE>GAMESS SCF Iteration Results</TITLE>
</HEAD>

<BODY>
<DIV ALIGN=CENTER>
   <APPLET CODE="GraphIt.class" CODEBASE="/Analysis/" WIDTH=600 HEIGHT=400>
      <PARAM NAME="TITLE" VALUE="GAMESS SCF Iteration Results">
      <PARAM NAME="XTITLE" VALUE="Iteration Number">
      <PARAM NAME="YTITLE" VALUE="Energy (Ry)">
      <PARAM NAME="DATA" VALUE="$outFile">
   </APPLET>
</DIV>
<BR>
<BR>
<BR>
<BR>
<BR>
</BODY>
</HTML>
end_tag
