#!/usr/local/bin/perl

## Primitive parser for G94 output.
##
## Produces ordered pairs of points for plotting 
## energy versus optimization run number via
## java graphing applet.

$dir = $ARGV[0];

##
## Name of parsed data file for plotting via applet is "optim.plot"
##

$inFile = $dir . "/gaussian.OUT";
$outDataFile = $dir . "/" . "optim.plot";

##
## Open files and parse "gaussian.OUT" for energy values
##

open (IN, "$inFile") || die ("Can't open $inFile: $!\n");
open (OUT, ">$outDataFile") || die ("Can't open $outDataFile: $!\n");
$optRun = 1;
while (<IN>) {

      if (/E\(RHF\)/) {
        @tmp = split(' ',$_);
        print OUT "$optRun $tmp[4]\n";
        $optRun++;
      }
}
close(OUT);
close(IN);

`cp $outDataFile /home/webflow/Jigsaw/Jigsaw/WWW/Analysis/graph.$$`;

##
## Open HTML file and print out HTML source
##

open (SHIT, ">/home/webflow/Jigsaw/Jigsaw/WWW/Analysis/test.html") ||
    die "FU\n";

print  SHIT <<"end_tag";
<HTML>
<HEAD>
<TITLE>Gaussian Optimization Run</TITLE>
</HEAD>

<BODY>
<DIV ALIGN=CENTER>
   <APPLET CODE="test.class" CODEBASE="Analysis" WIDTH=500 HEIGHT=300>
      <PARAM NAME="TITLE" VALUE="Gaussian 98 Optimization Run">
      <PARAM NAME="XTITLE" VALUE="Optimization Run Number">
      <PARAM NAME="YTITLE" VALUE="Energy (Ry)">
      <PARAM NAME="DATA" VALUE="graph.$$">
   </APPLET>
</DIV>
<BR>
<BR>
<BR>
<BR>
<BR>
<A HREF="/cgi-bin/s1">Go Home</A>
</BODY>
</HTML>
end_tag

print STDOUT "Location: http://heechee.osc.edu:8002/Analysis/test.html\n\n";

exit 0;
