#!/usr/local/bin/perl

## Primitive parser for G94 output.
##
## Produces ordered pairs of points for plotting 
## energy versus optimization run number via
## java graphing applet.

$dataHome = "/home/webflow/Data/";
$jigsawHome = "/home/webflow/Jigsaw/Jigsaw/WWW/";
$classHome = "/home/webflow/Jigsaw/Jigsaw/WWW/Analysis/test.class";

##
## Read contents of "login-ticket" into $uid
##

$ticketFile = "$dataHome" . "login-ticket-test";
open (IN, "$ticketFile") || die ("Can't open $ticketFile: $!\n");
while (<IN>) {
   chomp($uid = $_); 
}
close(IN);

##
## Read contents of "last-job" into $jobid
##

$lastJobFile = "$dataHome" . "$uid" . "/" . "last-job";
open (IN, "$lastJobFile") || die ("Can't open $lastJobFile: $!\n");
while (<IN>) {
   chomp($jobid = $_);
}
close(IN);

##
#### Build filename strings 
##

##
## Name of gaussian output from job run is "gaussian.OUT"
##

$inFile = "$dataHome" . "$uid" . "/" . "$jobid" . "/" . "gaussian.OUT";

##
## Name of parsed data file for plotting via applet is "optim.plot"
##

$outDataFile = "$dataHome" . "$uid" . "/" . "$jobid" . "/" . "optim.plot";
#$outDataFile = "$jigsawHome" . "Analysis" . "/" . "optim.plot";

##
## Name of HTML file to load applet is "optim.html"
##

#$outHtmlFile = "$jigsawHome" . "Analysis" . "/" . "optim.html";
$outHtmlFile = "$dataHome" . "$uid" . "/" . "$jobid" . "/" . "optim.html";

##
## Open files and parse "gaussian.OUT" for energy values
##

open (IN, "$inFile") || die ("Can't open $inFile: $!\n");
open (OUT, ">$outDataFile") || die ("Can't open $outDataFile: $!\n");
$optRun = 1;
while (<IN>) {

      if (/E\(RHF\)/) {
        @tmp = split(' ',$_);
        print OUT "$optRun $tmp[4]\n";
        $optRun++;
      }
}
close(OUT);
close(IN);

##
## Open HTML file and print out HTML source
##

open (OUT, ">$outHtmlFile");

print OUT <<"end_tag";
<HTML>
<HEAD>
<TITLE>Gaussian Optimization Run</TITLE>
</HEAD>

<BODY>
<DIV ALIGN=CENTER>
   <APPLET CODE="$classHome" WIDTH=500 HEIGHT=300>
      <PARAM NAME="TITLE" VALUE="Gaussian 98 Optimization Run">
      <PARAM NAME="XTITLE" VALUE="Optimization Run Number">
      <PARAM NAME="YTITLE" VALUE="Energy (Ry)">
      <PARAM NAME="DATA" VALUE="$outDataFile">
   </APPLET>
</DIV>
</BODY>
</HTML>
end_tag

close(OUT);
