/*
 * This example is from the book "Java Enterprise in a Nutshell".
 * Copyright (c) 1999 by O'Reilly & Associates.  
 * You may distribute this source code for non-commercial purposes only.
 * You may study, modify, and use this example for any purpose, as long as
 * this notice is retained.  Note that this example is provided "as is",
 * WITHOUT WARRANTY of any kind either expressed or implied.
 */

package stateless;

import javax.ejb.*;
import java.rmi.RemoteException;

/**
 * The "home" interface for the ProfileServerBean.  This interface provides
 * methods used to create beans on the server.  The container provider is
 * responsible for implementing this interface, most likely using
 * auto-generated Java classes derived from the interface bytecodes.
 */

public interface ProfileServerHome extends EJBHome {
  /**
   * Only a basic create() method provided here.
   */
  public ProfileServer create() throws CreateException, RemoteException;
}
