/*
 * This example is from the book "Java Enterprise in a Nutshell".
 * Copyright (c) 1999 by O'Reilly & Associates.  
 * You may distribute this source code for non-commercial purposes only.
 * You may study, modify, and use this example for any purpose, as long as
 * this notice is retained.  Note that this example is provided "as is",
 * WITHOUT WARRANTY of any kind either expressed or implied.
 */

import java.rmi.*;

/**
 * RegAccount: A utility class that registers an account with the local
 * RMI registry for remote access
 *
 * Example pg. 44, Java Enterprise in a Nutshell, 1st ed.
 * Author: Jim Farley
 */

public class RegAccount {
  public static void main(String argv[]) {
    try {
      // System.setSecurityManager(new RMISecurityManager());
      // Make an Account with a given name
      AccountImpl acct = new AccountImpl("JimF");

      // Register it with the local naming registry
      Naming.rebind("JimF", acct);
      System.out.println("Registered account.");

//       // Wait for clients to connect
//       "dummy".wait();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }
}
