/**
 * @(#)registeredUser.java
 * @author 	Ken Flurchick <kenf@osc.edu>
 * Date:	03/01/2000
 * Purpose:	Build the registeredUser.xml file which
 *			keeps track of user information.
 * @version 0.75
 *
 * Required Classes:
 *		parseRU
 */
import com.ibm.xml.*;
import com.ibm.xml.parser.*;
import com.ibm.xml.parsers.*;
import com.ibm.xml.parser.TXDocument;
import org.w3c.dom.*;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Text;
import org.w3c.dom.ProcessingInstruction;

import java.text.*;
import java.io.*;
import java.awt.*;
import java.net.*;
import java.util.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.Vector;
import java.util.Arrays.*;
import javax.swing.text.*;
import javax.swing.event.*;
import javax.swing.border.*;
/**
 * Class: registeredUser
 * <p>
 * This program can perform several operations for the
 * registeredUser XML file.
 * </p>
 * <ol>
 *	<li>Generate the file
 * 	<li>Add a User
 *	<li>Find a specific user information.
 *	<li>Modify (update) user information.
 *	<li>Remove a user.
 * </ol>
 */
public class registeredUser extends JFrame{
	JFrame parent;
/*
 * Miscelleanous class variables.
 */
	Element root, item, itemA, itemB;

	int nUsers = 0;
	int endIndex = 0;
	int startIndex = 0;
	String RUversion = "0.75";
	String defaultPFilter	= "..";
	String ruPath =  defaultPFilter + File.separator;
	String ruFile = ruPath + "registeredUser.xml";
	String dtdFile = ruPath + "registeredUser.dtd";
	String uidF = null;
	Hashtable userHash = new Hashtable();
	Vector sVec = new Vector();
	Hashtable fields = new Hashtable();
	Vector userKey = new Vector();
/*
 * Panel variables.
 */
	JPanel jp11 = new JPanel();
	JPanel jp12 = new JPanel();
	JPanel jp21 = new JPanel();
	JPanel jp22 = new JPanel();
	public JMenuBar menuBar = new JMenuBar();
	JScrollPane scroll1 = new JScrollPane();
	JScrollPane scroll2 = new JScrollPane();
	JTextArea listUsers1 = new JTextArea();
	JTextArea listUsers2 = new JTextArea();
	JPanel usersPanel1 = new JPanel();
	JPanel usersPanel2 = new JPanel();
	JTabbedPane jtp = new JTabbedPane(SwingConstants.TOP);
/*
 * Labels and text fields
 */
	JLabel targetFile1 = new JLabel("");
	JLabel targetFile2 = new JLabel("");
	JLabel userID1 = new JLabel("");
	JLabel userID2 = new JLabel("");
	JLabel primaryArea1 = new JLabel("");
	JLabel primaryArea2 = new JLabel("");
	JLabel projectN1 = new JLabel("");
	JLabel projectN2 = new JLabel("");
	JLabel email1 = new JLabel("");
	JLabel email2 = new JLabel("");
	JLabel organization1 = new JLabel("");
	JLabel organization2 = new JLabel("");
	JLabel User1 = new JLabel("");
	JLabel User2 = new JLabel("");
	JLabel uTitle1 = new JLabel("");
	JLabel uTitle2 = new JLabel("");
	JLabel lastName1 = new JLabel("");
	JLabel lastName2	= new JLabel("");
	JLabel firstName1 = new JLabel("");
	JLabel firstName2 = new JLabel("");
	JLabel middleName1 = new JLabel("");
	JLabel middleName2 = new JLabel("");
	JLabel Address1 = new JLabel("");
	JLabel Address2 = new JLabel("");
	JLabel street11	= new JLabel("");
	JLabel street12 = new JLabel("");
	JLabel street21 = new JLabel("");
	JLabel street22 = new JLabel("");
	JLabel mailStop1 = new JLabel("");
	JLabel mailStop2 = new JLabel("");
	JLabel building1 = new JLabel("");
	JLabel building2 = new JLabel("");
	JLabel city1 = new JLabel("");
	JLabel city2 = new JLabel("");
	JLabel state1 = new JLabel("");
	JLabel state2 = new JLabel("");
	JLabel zipcode1	= new JLabel("");
	JLabel zipcode2 = new JLabel("");
	JLabel zip41 = new JLabel("");
	JLabel zip42 = new JLabel("");
	JLabel contactInfo1 = new JLabel("");
	JLabel contactInfo2 = new JLabel("");
	JLabel officePhone1 = new JLabel("");
	JLabel officePhone2 = new JLabel("");
	JLabel faxNumber1 = new JLabel("");
	JLabel faxNumber2 = new JLabel("");

	JTextField tfuserID1 = new JTextField("");
	JTextField tfuserID2 = new JTextField("");
	JTextField tfprimaryArea1 = new JTextField("");
	JTextField tfprimaryArea2 = new JTextField("");
	JTextField tfprojectN1 = new JTextField("");
	JTextField tfprojectN2 = new JTextField("");
	JTextField tfemail1 = new JTextField("");
	JTextField tfemail2 = new JTextField("");
	JTextField tforganization1 = new JTextField("");
	JTextField tforganization2 = new JTextField("");
	JTextField tfuTitle1 = new JTextField("");
	JTextField tfuTitle2 = new JTextField("");
	JTextField tflastName1 = new JTextField("");
	JTextField tflastName2 = new JTextField("");
	JTextField tffirstName1 = new JTextField("");
	JTextField tffirstName2 = new JTextField("");
	JTextField tfmiddleName1 = new JTextField("");
	JTextField tfmiddleName2	= new JTextField("");
	JTextField tfstreet11 = new JTextField("");
	JTextField tfstreet12 = new JTextField("");
	JTextField tfstreet21 = new JTextField("");
	JTextField tfstreet22 = new JTextField("");
	JTextField tfmailStop1 = new JTextField("");
	JTextField tfmailStop2 = new JTextField("");
	JTextField tfbuilding1 = new JTextField("");
	JTextField tfbuilding2 = new JTextField("");
	JTextField tfcity1 = new JTextField("");
	JTextField tfcity2 = new JTextField("");
	JTextField tfstate1 = new JTextField("");
	JTextField tfstate2 = new JTextField("");
	JTextField tfzipcode1 = new JTextField("");
	JTextField tfzipcode2 = new JTextField("");
	JTextField tfzip41 = new JTextField("");
	JTextField tfzip42 = new JTextField("");
	JTextField tfofficePhone1 = new JTextField("");
	JTextField tfofficePhone2 = new JTextField("");
	JTextField tffaxNumber1	= new JTextField("");
	JTextField tffaxNumber2 = new JTextField("");
	JTextField tfName = new JTextField("");
	JTextField tfFile = new JTextField();

	Font headerFontT = new Font("Serif", Font.BOLD,18);
	Font headerFontD = new Font("Serif", Font.PLAIN,16);
	Font highlightFont = new Font("Courier", Font.BOLD,14);
	Color highlightColor = new Color(255,0,0);
	Border border = BorderFactory.createBevelBorder(
		BevelBorder.RAISED);
/**
 * Constructor: registeredUser
 * <p>
 * Methods:
 * </p>
 * <ul type="square">
 *	<li>placeFields{1 2}
 *		<br>- Create the text fields for the user data.
 * 		<p>
 * 		First tabbed pane called <i>List/Modify User</i>
 * 		<br>Process only modifications.
 * 		</p>
 * 		<ul>
 *			<li>List all registered users.
 *			<li>Find the data for a specific user.
 * 			<li>Remove a user.
 *			<li>Modify entries for a user.
 * 		</ul>
 * 		<p>
 * 		By default load the first entry in the
 * 		registeredUser.xml file.  Display a list
 * 		of users in the registeredUser.xml file.
 * 		</p>
 *	<li>controlPanel{1 2}
 *		<br>- Control panels for the tabbed panels.
 *	<li>placeUserList
 *		<br>- Create the scrolled panels to hold
 *		the user list.
 *	<li>userList
 *		<br> - Create the user list by parsing the XML
 *		file.
 * </ul>
 * @param		None
 * @return		None
 * @throws		None
 */
	public registeredUser () {
		super("SciPortal Registered Users Admistration Form");
/*
 * Set the frame and panel sizes
 */
		int fw = 950;
		int fh = 700;
		int cw = 225;
		setSize(fw, fh);
		Color mColor = new Color(204, 255, 255);

		parent = this;

		Container c = getContentPane();
		c.setBackground(Color.white);
/*
 * Fill the panels (invoke the specific methods).
 */
		keyVector(); // Fill the keyword vector.

		placeFields1();
		controlPanel1();
		placeFields2();
		controlPanel2();
		placeUserList();

		JSplitPane jsp1 = new JSplitPane(
			JSplitPane.HORIZONTAL_SPLIT, jp11, jp12);

		JSplitPane jspA  = new JSplitPane(
			JSplitPane.HORIZONTAL_SPLIT, jsp1, usersPanel1);

		JSplitPane jsp2 = new JSplitPane(
			JSplitPane.HORIZONTAL_SPLIT, jp21, jp22);

		JSplitPane jspB  = new JSplitPane(
			JSplitPane.HORIZONTAL_SPLIT, jsp2, usersPanel2);

		jtp.addTab("List/Modify User", jspA);
		jtp.addTab("Add User", jspB);

		jtp.setForeground(new Color(204,104,104));
		jtp.setBackground(new Color(198,198,198));

		c.add(jtp);

// add File->Exit menu
		JMenu Exit = new JMenu("Exit Application");
		menuBar.add(Exit);

		Exit.add( new ExitAction());
		setJMenuBar(menuBar);
	}
/**
 * Constructor: placeFields1
 * <p>
 * Place the  JLabels and JTextFields
 * on the panel for the <i>List/Modify User</i> tabbed pane.
 * </p>
 * <p>
 * Generate a button for the file browser.
 * Once the file is selected, generate the user list
 * and display it.
 * </p>
 * @param		None
 * @return		None
 * @throws		None
 */
	public void placeFields1(){

		jp11.setLayout(new GridLayout(28,2));
		jp11.setBackground(new Color(204, 204, 255));
		jp11.setBorder(border);
		JButton fileButtonP1 = new JButton(
			"Select a different file.");
		targetFile1.setText(ruFile);
		targetFile1.setToolTipText(
			"Find the file/Generate the List");
		targetFile1.setFont(headerFontT);
		targetFile1.setForeground(new Color(15, 42, 42));
		jp11.add(targetFile1);
		jp11.add(fileButtonP1);

		fileButtonP1.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae1) {
				JFileChooser chooser1 = new JFileChooser();
				chooser1.setCurrentDirectory(
					new File(defaultPFilter));
				int option1 = chooser1.showOpenDialog(parent);
				if(option1 == JFileChooser.APPROVE_OPTION) {
					File g1 = chooser1.getSelectedFile();
					ruPath = g1.getAbsolutePath();
					ruFile = ruPath;
					targetFile1.setText(ruPath);
					targetFile1.setForeground(new Color(255,51,0));
					getUserList();
				} else {
					targetFile1.setText("You canceled.");
				}
			}
		});

		JButton List1 = new JButton("List the users.");
		jp11.add(new JLabel("Regenerate the users list."));
		jp11.add(List1);

		// List of users button.
		List1.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae1) {
				getUserList();
			}
		});

		userID1.setText("User ID");
		tfuserID1.setText("Enter User ID");
		primaryArea1.setText("Primary Science Discipline");
		tfprimaryArea1.setText("CCM");
		projectN1.setText("Project Number(optional)");
		tfprojectN1.setText(" ");
		email1.setText("Enter eMail Address");
		tfemail1.setText("E-mail");
		organization1.setText("Organization");
		tforganization1.setText("Enter Organization");
		User1.setText("User Personal Information");
		uTitle1.setText("Title (Dr., Mr., Mrs., Ms., None)");
		tfuTitle1.setText(" ");
		lastName1.setText("Family Name");
		tflastName1.setText("Family Name");
		firstName1.setText("Given Name");
		tffirstName1.setText("Given Name");
		middleName1.setText("Enter Middle Name (Optional)");
		tfmiddleName1.setText(" ");
		Address1.setText("Enter Mailing Address Below.");
		street11.setText("Address 1");
		tfstreet11.setText("Address 1");
		street21.setText("Address 2 (Optional)");
		tfstreet21.setText(" ");
		mailStop1.setText("Mail Stop (Optional)");
		tfmailStop1.setText(" ");
		building1.setText("Building (Optional)");
		tfbuilding1.setText(" ");
		city1.setText("City");
		tfcity1.setText("City");
		state1.setText("State");
		tfstate1.setText("State");
		zipcode1.setText("Zip Code");
		tfzipcode1.setText("Zip Code");
		zip41.setText("Zip + 4 (Optional)");
		tfzip41.setText(" ");
		contactInfo1.setText("Enter contact information below.");
		officePhone1.setText("Phone Number");
		tfofficePhone1.setText(
			"(area code)number-number x(extension)");
		faxNumber1.setText("Fax Number");
		tffaxNumber1.setText(
			"(area code)number-number x(extension)");

		jp11.add(userID1);
		jp11.add(tfuserID1);
		jp11.add(primaryArea1);
		jp11.add(tfprimaryArea1);
		jp11.add(projectN1);
		jp11.add(tfprojectN1);
		jp11.add(email1);
		jp11.add(tfemail1);
		jp11.add(organization1);
		jp11.add(tforganization1);
		jp11.add(User1);
		jp11.add(new JLabel(" "));
		jp11.add(uTitle1);
		jp11.add(tfuTitle1);
		jp11.add(lastName1);
		jp11.add(tflastName1);
		jp11.add(firstName1);
		jp11.add(tffirstName1);
		jp11.add(middleName1);
		jp11.add(tfmiddleName1);
		jp11.add(Address1);
		jp11.add(new JLabel(" "));
		jp11.add(street11);
		jp11.add(tfstreet11);
		jp11.add(street21);
		jp11.add(tfstreet21);
		jp11.add(mailStop1);
		jp11.add(tfmailStop1);
		jp11.add(building1);
		jp11.add(tfbuilding1);
		jp11.add(city1);
		jp11.add(tfcity1);
		jp11.add(state1);
		jp11.add(tfstate1);
		jp11.add(zipcode1);
		jp11.add(tfzipcode1);
		jp11.add(zip41);
		jp11.add(tfzip41);
		jp11.add(contactInfo1);
		jp11.add(new JLabel(" "));
		jp11.add(officePhone1);
		jp11.add(tfofficePhone1);
		jp11.add(faxNumber1);
		jp11.add(tffaxNumber1);

		JButton Reset1 = new JButton("Reset the form.");
		jp11.add(new JLabel("  "));
		jp11.add(Reset1);

		Reset1.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae1) {
				resetForm(1);
			}
		});
	}
/**
 * Method: 	controlPanel1()
 * <p>
 *  Controls (buttons) for the
 *  <i>List/Modify User</i> tabbed pane.
 * </p>
 * @param	None
 * @return	None
 * @throws	None
 */
	public void controlPanel1(){
		String userName = null;
		String TAG = null;

		jp12.setLayout(new GridLayout(24,1));
		jp12.setBackground(new Color(204, 204, 255));
		Border border = BorderFactory.createBevelBorder(
			BevelBorder.RAISED);
		jp12.setBorder(border);
		JLabel headerJP1 = new JLabel("Modify/Remove A User");
		headerJP1.setBackground(new Color(255, 204, 255));
		headerJP1.setFont(headerFontD);

		jp12.add(new JLabel("  "));
		jp12.add(new JLabel("  "));

		JLabel headerName = new JLabel(
			"Specify the user ID to locate.");
		JLabel ulName = new JLabel(
			"Click to find the user information.");
		JButton findName = new JButton(
			"Find the user information.");
		jp12.add(headerName);
		jp12.add(new JLabel("  "));
		jp12.add(tfName);
		jp12.add(new JLabel("  "));
		jp12.add(ulName);
		jp12.add(findName);
/**
 *	Find the user information.
 */
		findName.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae1) {
				uidF = tfName.getText();
				findUser(uidF);
			}
		});
/**
 * Remove the user from the XML file
 * and regenerate the user list.
 */
		jp12.add(new JLabel("  "));
		jp12.add(new JLabel("  "));

		JLabel headerJP2 = new JLabel(
			"Remove the user information.");
		headerJP2.setBackground(new Color(255, 204, 255));
		headerJP2.setFont(headerFontD);
		jp12.add(headerJP2);

		jp12.add(new JLabel("  "));
		JButton Remove = new JButton(
			"Remove the user information.");
		jp12.add(Remove);
		jp12.add(new JLabel("  "));

		Remove.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae1) {
				// Parse the registered user file and locate
				// the specific uid.
				parseRU pf = new parseRU();
				if( ! pf.removeUser(ruFile, dtdFile, uidF)){
					System.out.println("ERROR: remove user failed");
				}
				resetForm(1);
				getUserList();
			}
		});

/**
 *	<p>
 *	Update the user information.
 *  This is done by
 *	</p>
 *  <ol>
 *		<li>Remove the user.
 *		<li>Add the user.
 *	</ol>
 */
		jp12.add(new JLabel("  "));
		jp12.add(new JLabel("  "));

		JLabel headerJP3 = new JLabel(
			"Update the user information.");
		headerJP3.setBackground(new Color(255, 204, 255));
		headerJP3.setFont(headerFontD);
		jp12.add(headerJP3);
		jp12.add(new JLabel("  "));

		JButton Update = new JButton("Update");
		jp12.add(Update);

		Update.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae1) {
				// Get the user ID
				uidF = tfName.getText();

				// Remove the user information.
				parseRU pf = new parseRU();
				if( ! pf.removeUser(ruFile, dtdFile, uidF)){
					System.out.println("ERROR: remove user failed");
				}
				// Set up the Hashtable of new information.
				fields.put(userKey.get(0), tfuserID1.getText());
				fields.put(userKey.get(1), tfprimaryArea1.getText());
				fields.put(userKey.get(2), tfprojectN1.getText());
				fields.put(userKey.get(3), tfemail1.getText());
				fields.put(userKey.get(4), tforganization1.getText());
				fields.put(userKey.get(5), tfuTitle1.getText());
				fields.put(userKey.get(6), tflastName1.getText());
				fields.put(userKey.get(7), tffirstName1.getText());
				fields.put(userKey.get(8), tfmiddleName1.getText());
				fields.put(userKey.get(9), tfstreet11.getText());
				fields.put(userKey.get(10), tfstreet21.getText());
				fields.put(userKey.get(11), tfmailStop1.getText());
				fields.put(userKey.get(12), tfbuilding1.getText());
				fields.put(userKey.get(13), tfcity1.getText());
				fields.put(userKey.get(14), tfstate1.getText());
				fields.put(userKey.get(15), tfzipcode1.getText());
				fields.put(userKey.get(16), tfzip41.getText());
				fields.put(userKey.get(17), tfofficePhone1.getText());
				fields.put(userKey.get(18), tffaxNumber1.getText());
				pf.addUser(ruFile, dtdFile, fields);
				findUser(uidF);
				getUserList();
			}
		});

		JLabel exitL = new JLabel("Exit the User program.");
		JButton exitB = new JButton("Exit");
		jp12.add(exitL);
		jp12.add(exitB);

		exitB.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae1) {
				System.out.println("Leaving the program.");
				System.exit(0);
			}
		});
	}
/**
 * Method:	placeFields2
 * <p>
 * Place the JLabels and JTextFields
 * on the <i>Add a User</i> tabbed pane.
 * Generate a button for the file browser.
 * Once the file is selected, generate the user list
 * and display it.
 * </p>
 * @param	None
 * @return	None
 * @throws	None
 */
	public void placeFields2(){

		jp21.setLayout(new GridLayout(26,2));
		jp21.setBackground(new Color(204, 204, 255));
		jp21.setBorder(border);

		JLabel fileLabel2 = new JLabel(
			"Select a different file.");
		tfFile.setText(ruFile);
		tfFile.setToolTipText( "Create a new file.");
		tfFile.setFont(headerFontT);
		tfFile.setForeground(new Color(15, 42, 42));
		jp21.add(fileLabel2);
		jp21.add(tfFile);

		userID2.setText("User ID");
		tfuserID2.setText("Enter User ID");
		primaryArea2.setText("Primary Science Discipline");
		tfprimaryArea2.setText("CCM");
		projectN2.setText("Project Number(optional)");
		tfprojectN2.setText(" ");
		email2.setText("Enter eMail Address");
		tfemail2.setText("E-mail");
		organization2.setText("Organization");
		tforganization2.setText("Enter Organization");
		User2.setText("User Personal Information");
		uTitle2.setText("Title (Dr., Mr., Mrs., Ms., None)");
		tfuTitle2.setText(" ");
		lastName2.setText("Family Name");
		tflastName2.setText("Family Name");
		firstName2.setText("Given Name");
		tffirstName2.setText("Given Name");
		middleName2.setText("Enter Middle Name (Optional) ");
		tfmiddleName2.setText(" ");
		Address2.setText("Enter Mailing Address Below.");
		street12.setText("Address 1");
		tfstreet12.setText("Address 1");
		street22.setText("Address 2 (Optional)");
		tfstreet22.setText(" ");
		mailStop2.setText("Mail Stop (Optional)");
		tfmailStop2.setText(" ");
		building2.setText("Building (Optional)");
		tfbuilding2.setText(" ");
		city2.setText("City");
		tfcity2.setText("City");
		state2.setText("State");
		tfstate2.setText("State");
		zipcode2.setText("Zip Code");
		tfzipcode2.setText("Zip Code");
		zip42.setText("Zip + 4 (Optional)");
		tfzip42.setText(" ");
		contactInfo2.setText("Enter contact information below.");
		officePhone2.setText("Phone Number");
		tfofficePhone2.setText(
			"(area code)number-number x(extension)");
		faxNumber2.setText("Fax Number");
		tffaxNumber2.setText(
			"(area code)number-number x(extension)");
		jp21.add(userID2);
		jp21.add(tfuserID2);
		jp21.add(primaryArea2);
		jp21.add(tfprimaryArea2);
		jp21.add(projectN2);
		jp21.add(tfprojectN2);
		jp21.add(email2);
		jp21.add(tfemail2);
		jp21.add(organization2);
		jp21.add(tforganization2);
		jp21.add(User2);
		jp21.add(new JLabel(" "));
		jp21.add(uTitle2);
		jp21.add(tfuTitle2);
		jp21.add(lastName2);
		jp21.add(tflastName2);
		jp21.add(firstName2);
		jp21.add(tffirstName2);
		jp21.add(middleName2);
		jp21.add(tfmiddleName2);
		jp21.add(Address2);
		jp21.add(new JLabel(" "));
		jp21.add(street12);
		jp21.add(tfstreet12);
		jp21.add(street22);
		jp21.add(tfstreet22);
		jp21.add(mailStop2);
		jp21.add(tfmailStop2);
		jp21.add(building2);
		jp21.add(tfbuilding2);
		jp21.add(city2);
		jp21.add(tfcity2);
		jp21.add(state2);
		jp21.add(tfstate2);
		jp21.add(zipcode2);
		jp21.add(tfzipcode2);
		jp21.add(zip42);
		jp21.add(tfzip42);
		jp21.add(contactInfo2);
		jp21.add(new JLabel(" "));
		jp21.add(officePhone2);
		jp21.add(tfofficePhone2);
		jp21.add(faxNumber2);
		jp21.add(tffaxNumber2);

		JButton Reset2 = new JButton("Reset the form.");
		jp21.add(new JLabel("  "));
		jp21.add(Reset2);

		Reset2.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae1) {
				resetForm(2);
			}
		});

		JButton List2 = new JButton("List the users.");
		jp21.add(new JLabel("Regenerate the users list."));
		jp21.add(List2);

		// List of users button.
		List2.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae1) {
				getUserList();
			}
		});
	}
/**
 * Method: 	controlPanel2
 * <p>
 * Controls (buttons) for the <i>Add User</i> tabbed pane.
 * </p>
 * @param	None
 * @return	None
 * @throws	None
 */
	public void controlPanel2(){
		String userName = null;
		String TAG = null;

		jp22.setLayout(new GridLayout(20,1));
		jp22.setBackground(new Color(204, 204, 255));
		Border border = BorderFactory.createBevelBorder(
			BevelBorder.RAISED);
		jp22.setBorder(border);
		JLabel headerJP1 = new JLabel("Add A User");
		headerJP1.setBackground(new Color(255, 204, 255));
		headerJP1.setFont(headerFontD);
/**
 * Add a user
 */
		JButton Add = new JButton("Add the user.");

		jp22.add(headerJP1);
		jp22.add(Add);

		Add.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae1) {
				// Set up the Hashtable of new information
				fields.put(userKey.get(0), tfuserID2.getText());
				fields.put(userKey.get(1), tfprimaryArea2.getText());
				fields.put(userKey.get(2), tfprojectN2.getText());
				fields.put(userKey.get(3), tfemail2.getText());
				fields.put(userKey.get(4), tforganization2.getText());
				fields.put(userKey.get(5), tfuTitle2.getText());
				fields.put(userKey.get(6), tflastName2.getText());
				fields.put(userKey.get(7), tffirstName2.getText());
				fields.put(userKey.get(8), tfmiddleName2.getText());
				fields.put(userKey.get(9), tfstreet12.getText());
				fields.put(userKey.get(10), tfstreet22.getText());
				fields.put(userKey.get(11), tfmailStop2.getText());
				fields.put(userKey.get(12), tfbuilding2.getText());
				fields.put(userKey.get(13), tfcity2.getText());
				fields.put(userKey.get(14), tfstate2.getText());
				fields.put(userKey.get(15), tfzipcode2.getText());
				fields.put(userKey.get(16), tfzip42.getText());
				fields.put(userKey.get(17), tfofficePhone2.getText());
				fields.put(userKey.get(18), tffaxNumber2.getText());

				parseRU pf = new parseRU();
				pf.addUser(ruFile, dtdFile, fields);
				uidF = tfuserID2.getText();
				findUser(uidF);
				getUserList();
			}
		});

		jp22.add(new JLabel("  "));
		jp22.add(new JLabel("  "));

		JLabel headerJP3 = new JLabel("Create the File");
		headerJP3.setBackground(new Color(255, 204, 255));
		headerJP3.setFont(headerFontD);
		jp22.add(headerJP3);
		jp22.add(new JLabel("  "));
/*
 * Create the registereduser File.
 */
		JButton cAdd = new JButton(
			"Create the file and add this user.");
		jp22.add(cAdd);

		cAdd.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae1) {
				ruFile = ruPath + tfFile.getText();
				System.out.println("New file is ruFile = " + ruFile);
				createRU();
			}
		});

		JLabel exit2L = new JLabel("Exit the User program.");
		JButton exit2B = new JButton("Exit");
		jp22.add(exit2L);
		jp22.add(exit2B);

		exit2B.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae1) {
				System.out.println("Leaving the program.");
				System.exit(0);
			}
		});
	}
/**
 * Method: placeUserList
 * <p>
 * Text areas for User list.
 * This will be displayed on both tabbed panes.
 * </p>
 * @param		None
 * @return		None
 * @throws		None
 */
	public void placeUserList(){
/*
 * Create the User List textArea panel for the first tab.
 */
		usersPanel1.setLayout(new GridLayout(1,1));
		usersPanel1.setBackground(new Color(204, 204, 255));
		usersPanel1.setBorder(border);
		scroll1.setVerticalScrollBarPolicy(
			ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
		scroll1.setHorizontalScrollBarPolicy(
			ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);
		scroll1.getViewport().add(listUsers1);
		usersPanel1.add(scroll1);
/*
 * Create the User List textArea panel for the second tab.
 */
		usersPanel2.setLayout(new GridLayout(1,1));
		usersPanel2.setBackground(new Color(204, 204, 255));
		usersPanel2.setBorder(border);
		scroll2.setVerticalScrollBarPolicy(
			ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
		scroll2.setHorizontalScrollBarPolicy(
			ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);
		scroll2.getViewport().add(listUsers2);
		usersPanel2.add(scroll2);
	}
/**
 * Method: findUser
 * <p>
 * Find the specified user using the parseRU object.
 * Locate all the user information and fill the fields.
 * </p>
 * @param	String uid - User ID
 * @return	int entryNum - The number of the user or -1 (not found)
 * @throws	None
 */
	public void findUser(String user){
		String usrs = null;

		parseRU pf = new parseRU();
		nUsers = pf.doParseF(ruFile, dtdFile, userHash);
		if(nUsers == 0){
			System.out.println("Error in generating hash table");
			System.exit(4);
		}
		usrs = (String)userHash.get(user);
		if(usrs != null){
			startIndex = 0;
			endIndex = usrs.indexOf("::", startIndex);
			tfuserID1.setText(usrs.substring(startIndex, endIndex));

			startIndex = endIndex + 2;
			endIndex = usrs.indexOf("::", startIndex);
			tfprimaryArea1.setText(usrs.substring(startIndex, endIndex));

			startIndex = endIndex + 2;
			endIndex = usrs.indexOf("::", startIndex);
			tfprojectN1.setText(usrs.substring(startIndex, endIndex));

			startIndex = endIndex + 2;
			endIndex = usrs.indexOf("::", startIndex);
			tfemail1.setText(usrs.substring(startIndex, endIndex));

			startIndex = endIndex + 2;
			endIndex = usrs.indexOf("::", startIndex);
			tforganization1.setText(usrs.substring(startIndex, endIndex));

			startIndex = endIndex + 2;
			endIndex = usrs.indexOf("::", startIndex);
			tfuTitle1.setText(usrs.substring(startIndex, endIndex));

			startIndex = endIndex + 2;
			endIndex = usrs.indexOf("::", startIndex);
			tflastName1.setText(usrs.substring(startIndex, endIndex));

			startIndex = endIndex + 2;
			endIndex = usrs.indexOf("::", startIndex);
			tffirstName1.setText(usrs.substring(startIndex, endIndex));

			startIndex = endIndex + 2;
			endIndex = usrs.indexOf("::", startIndex);
			tfmiddleName1.setText(usrs.substring(startIndex, endIndex));

			startIndex = endIndex + 2;
			endIndex = usrs.indexOf("::", startIndex);
			tfstreet11.setText(usrs.substring(startIndex, endIndex));

			startIndex = endIndex + 2;
			endIndex = usrs.indexOf("::", startIndex);
			tfstreet21.setText(usrs.substring(startIndex, endIndex));

			startIndex = endIndex + 2;
			endIndex = usrs.indexOf("::", startIndex);
			tfmailStop1.setText(usrs.substring(startIndex, endIndex));

			startIndex = endIndex + 2;
			endIndex = usrs.indexOf("::", startIndex);
			tfbuilding1.setText(usrs.substring(startIndex, endIndex));

			startIndex = endIndex + 2;
			endIndex = usrs.indexOf("::", startIndex);
			tfcity1.setText(usrs.substring(startIndex, endIndex));

			startIndex = endIndex + 2;
			endIndex = usrs.indexOf("::", startIndex);
			tfstate1.setText(usrs.substring(startIndex, endIndex));

			startIndex = endIndex + 2;
			endIndex = usrs.indexOf("::", startIndex);
			tfzipcode1.setText(usrs.substring(startIndex, endIndex));

			startIndex = endIndex + 2;
			endIndex = usrs.indexOf("::", startIndex);
			tfzip41.setText(usrs.substring(startIndex, endIndex));

			startIndex = endIndex + 2;
			endIndex = usrs.indexOf("::", startIndex);
			tfofficePhone1.setText(usrs.substring(startIndex, endIndex));

			startIndex = endIndex + 2;
			endIndex = usrs.indexOf("::", startIndex);
			tffaxNumber1.setText(usrs.substring(startIndex, endIndex));
		} else {
			tfName.setText("ERROR: user name is invalid!");
		}
	}
 /**
 * Method: 	getUserList()
 * <p>
 * Get the list of users and write it to the panels.
 * </p>
 * @param	None
 * @return	None
 * @throws	None
 */
	public void getUserList(){
		int nUsers = 0;
		String lup;

		listUsers1.setText(" ");
		listUsers2.setText(" ");

		parseRU pf = new parseRU();
		nUsers = pf.doParse(ruFile, dtdFile, userHash);
		if(nUsers == 0){
			System.out.println("Error in generating hash table");
			System.exit(4);
		}
		lup = (String)userHash.get("lastUpdate");
		listUsers1.append("Last update : " + lup + "\n");
		listUsers2.append("Last update : " + lup + "\n");
		listUsers1.append(
			"The number of user entries\t" + nUsers + "\n");
		listUsers2.append(
			"The number of user entries\t" + nUsers + "\n");
		String usrs = (String)userHash.get("userID");
		// System.out.println("usrs string in ru = " + usrs);
		String usrFirst = (String)userHash.get("firstName");
		String usrMiddle = (String)userHash.get("middleName");
		String usrLast = (String)userHash.get("lastName");
		if(nUsers > 1){
			int UstartIndex = 0;
			int FstartIndex = 0;
			int MstartIndex = 0;
			int LstartIndex = 0;
			int endIndex = 0;
			for(int l = 0; l < nUsers; l++){
				endIndex = usrs.indexOf("::", UstartIndex);
				String usr = usrs.substring(UstartIndex, endIndex);
				UstartIndex = endIndex + 2;
				endIndex = usrFirst.indexOf("::", FstartIndex);
				String fName = usrFirst.substring(FstartIndex, endIndex);
				FstartIndex  = endIndex + 2;
				endIndex = usrMiddle.indexOf("::", MstartIndex);
				String mName = usrMiddle.substring(MstartIndex, endIndex);
				MstartIndex  = endIndex + 2;
				endIndex = usrLast.indexOf("::", LstartIndex);
				String lName = usrLast.substring(LstartIndex, endIndex);
				LstartIndex = endIndex + 2;

				listUsers1.append(l + "   " + usr + "\t" + fName + " "
					+ mName + " " + lName + "\n");
				listUsers2.append(usr + "\t" + fName + " "
						+ mName + " " + lName + "\n");
			}
		} else {
			listUsers1.append(
				"The number of user entries\t\t" + nUsers + "\n");
			listUsers1.append(usrs + "\t\t" + usrFirst + " "
				+ usrMiddle + " " + usrLast + "\n");
			listUsers2.append(
				"The number of user entries\t\t" + nUsers + "\n");
			listUsers2.append(usrs + "\t\t" + usrFirst + " "
				+ usrMiddle + " " + usrLast + "\n");
		}
	}
/**
 * Method: 	resetForm()
 * <p>
 * Reset the forms.
 * </p>
 * @param	int panelNumber
 * @return	None
 * @throws	None
 */
 	public void resetForm(int panelNumber){
		switch(panelNumber){
			case 1: {
				tfuserID1.setText("Enter User ID");
				tfprimaryArea1.setText("CCM");
				tfprojectN1.setText(" ");
				tfemail1.setText("E-mail");
				tforganization1.setText("Enter Organization");
				tfuTitle1.setText(" ");
				tflastName1.setText("Family Name");
				tffirstName1.setText("Given Name");
				tfmiddleName1.setText(" ");
				tfstreet11.setText("Address 1");
				tfstreet21.setText(" ");
				tfmailStop1.setText(" ");
				tfbuilding1.setText(" ");
				tfcity1.setText("City");
				tfstate1.setText("State");
				tfzipcode1.setText("Zip Code");
				tfzip41.setText(" ");
				tfofficePhone1.setText(
					"(area code)number-number x(extension)");
				tffaxNumber1.setText(
					"(area code)number-number x(extension)");
				break;
			} case 2: {
				tfuserID2.setText("Enter User ID");
				tfprimaryArea2.setText("CCM");
				tfprojectN2.setText(" ");
				tfemail2.setText("E-mail");
				tforganization2.setText("Enter Organization");
				tfuTitle2.setText(" ");
				tflastName2.setText("Family Name");
				tffirstName2.setText("Given Name");
				tfmiddleName2.setText(" ");
				tfstreet12.setText("Address 1");
				tfstreet22.setText(" ");
				tfmailStop2.setText(" ");
				tfbuilding2.setText(" ");
				tfcity2.setText("City");
				tfstate2.setText("State");
				tfzipcode2.setText("Zip Code");
				tfzip42.setText(" ");
				tfofficePhone2.setText(
					"(area code)number-number x(extension)");
				tffaxNumber2.setText(
					"(area code)number-number x(extension)");
				break;
			} default: {
				System.out.println("Bad panel number.\n");
			}
		}
	}
/**
 * Method: 	keyVector()
 * <p>
 * Set the key values.
 * </p>
 * @param	None
 * @return	None
 * @throws	None
 */
	void keyVector(){
		userKey.add("userID");
		userKey.add("primaryArea");
		userKey.add("projectNumber");
		userKey.add("email");
		userKey.add("organization");
		userKey.add("title");
		userKey.add("lastName");
		userKey.add("firstName");
		userKey.add("middleName");
		userKey.add("street1");
		userKey.add("street2");
		userKey.add("mailStop");
		userKey.add("building");
		userKey.add("city");
		userKey.add("state");
		userKey.add("zipcode");
		userKey.add("zip4");
		userKey.add("officePhone");
		userKey.add("faxNumber");
	}
/**
 * Method: 	createRU()
 * <p>
 * Use TX XML document to create the registered user
 * XML file.
 * </p>
 * @param	None
 * @return	None
 * @throws	None
 */
	protected void createRU(){
/*
 * Now, begin creating the registeredUser.xml file.
 */
		try {
			Document doc = new TXDocument();

			String f1 = "MM  dd  yyyy  hh  mm";
			String f2 = "MM/dd/yyyy  hh:mm";
			SimpleDateFormat in = new SimpleDateFormat(f1);
			SimpleDateFormat out = new SimpleDateFormat(f2);

 			Calendar cal = Calendar.getInstance();
			String datestring = (
				  cal.get(Calendar.MONTH) + 1) + "  "
				+ cal.get(Calendar.DAY_OF_MONTH) + "  "
				+ cal.get(Calendar.YEAR) + "  "
				+ cal.get(Calendar.HOUR) + "  "
				+ cal.get(Calendar.MINUTE);
			Date curr = in.parse(datestring);

			// Make <registeredUser> element root and add it
			// to the document.
			root = doc.createElement("registeredUser");
			root.setAttribute("lastUpdate", out.format(curr));

			//  Make <User> element and add it
			//  as a child of root
			item = doc.createElement("User");
			item.setAttribute("UID", tfuserID2.getText());

			//  Make <primaryArea> element and add it
			//  as a child of User
			itemA = doc.createElement("primaryArea");
			itemA.appendChild(doc.createTextNode(
				tfprimaryArea2.getText()));
			item.appendChild(itemA);

			//  Make <projectNumber> element and add it
			//  as a child of User
			itemA = doc.createElement("projectNumber");
			itemA.appendChild(doc.createTextNode(
				tfprojectN2.getText()));
			item.appendChild(itemA);

			//  Make <email> element and add it
 			//  as a child of User
			itemA = doc.createElement("email");
			itemA.appendChild(doc.createTextNode(
				tfemail2.getText()));
			item.appendChild(itemA);

			//  Make <organization> element and add it
			//  as a child of User
			itemA = doc.createElement("organization");
			itemA.appendChild(doc.createTextNode(
				tforganization2.getText()));
			item.appendChild(itemA);

			//  Make <Person> element and add it
			//  as a child of User
			itemA = doc.createElement("Person");

			//  Make <title> element and add it
			//  as a child of Person
			itemB = doc.createElement("title");
			itemB.appendChild(doc.createTextNode(
				tfuTitle2.getText()));
			itemA.appendChild(itemB);

			//  Make <lastName> element and add it
			//  as a child of Person
			itemB = doc.createElement("lastName");
			itemB.appendChild(doc.createTextNode(
				tflastName2.getText()));
			itemA.appendChild(itemB);

			//  Make <firstName> element and add it
			//  as a child of Person
			itemB = doc.createElement("firstName");
			itemB.appendChild(doc.createTextNode(
				tffirstName2.getText()));
			itemA.appendChild(itemB);

			//  Make <middleName> element and add it
			//  as a child of Person
			itemB = doc.createElement("middleName");
			itemB.appendChild(doc.createTextNode(
				tfmiddleName2.getText()));
			itemA.appendChild(itemB);

			//  Add <Person> as a child of <user>
			item.appendChild(itemA);

			//  Make <Address> element and add it
			//  as a child of User
			itemA = doc.createElement("Address");

			//  Make <street1> element and add it
			//  as a child of Address
			itemB = doc.createElement("street1");
			itemB.appendChild(doc.createTextNode(
				tfstreet12.getText()));
			itemA.appendChild(itemB);

			//  Make <street2> element and add it
			//  as a child of Address
			itemB = doc.createElement("street2");
			itemB.appendChild(doc.createTextNode(
				tfstreet22.getText()));
			itemA.appendChild(itemB);

			//  Make <mailStop> element and add it
			//  as a child of Address
			itemB = doc.createElement("mailStop");
			itemB.appendChild(doc.createTextNode(
				tfmailStop2.getText()));
			itemA.appendChild(itemB);

			//  Make <building> element and add it
			//  as a child of Address
			itemB = doc.createElement("building");
			itemB.appendChild(doc.createTextNode(
				tfbuilding2.getText()));
			itemA.appendChild(itemB);

			//  Make <city> element and add it
			//  as a child of Address
			itemB = doc.createElement("city");
			itemB.appendChild(doc.createTextNode(
				tfcity2.getText()));
			itemA.appendChild(itemB);

			//  Make <state> element and add it
			//  as a child of Address
			itemB = doc.createElement("state");
			itemB.appendChild(doc.createTextNode(
				tfstate2.getText()));
			itemA.appendChild(itemB);

			//  Make <zipcode> element and add it
 			//  as a child of Address
			itemB = doc.createElement("zipcode");
			itemB.appendChild(doc.createTextNode(
				tfzipcode2.getText()));
			itemA.appendChild(itemB);

			//  Make <zip4> element and add it
			//  as a child of Address
			itemB = doc.createElement("zip4");
			itemB.appendChild(doc.createTextNode(
				tfzip42.getText()));
			itemA.appendChild(itemB);

			//  Add <Address> as a child of <user>
			item.appendChild(itemA);

			//  Make <contact> element and add it
			//  as a child of User
			itemA = doc.createElement("contact");

			//  Make <officePhone> element and add it
			//  as a child of contact
			itemB = doc.createElement("officePhone");
			itemB.appendChild(doc.createTextNode(
				tfofficePhone2.getText()));
			itemA.appendChild(itemB);

			//  Make <faxNumber> element and add it
			//  as a child of contact
			itemB = doc.createElement("faxNumber");
			itemB.appendChild(doc.createTextNode(
				tffaxNumber2.getText()));
			itemA.appendChild(itemB);

			//  Add <contact> as a child of <user>
			item.appendChild(itemA);

			//  Add <contact> as a child of <user>
			root.appendChild(item);

			// Now root is added to the doc.
			doc.appendChild(root);

			// Show the XML document
			((TXDocument)doc).setVersion("1.0");
			// ((TXDocument)doc).printWithFormat(
			//	new PrintWriter(System.out));

			// System.out.println("ruFile = " + ruFile);
			try{
				PrintWriter ruFileOut = new PrintWriter(
					new FileWriter(ruFile, false));
				((TXDocument)doc).printWithFormat(ruFileOut);
			} // End of try block for ruFileOut.
			catch(IOException e){
				System.out.println("Error opening ruFileOut.");
				System.exit(0);
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
/**
 * Method: 	processWindowEvent()
 * <p>
 * Override the WindowEvent so that on
 * Window Close the process exits.
 * </p>
 * @param	WindowEvent e
 * @return	None
 * @throws	None
 */
	protected void processWindowEvent(WindowEvent e){
		super.processWindowEvent(e);
		if (e.getID() == WindowEvent.WINDOW_CLOSING) {
			System.exit(0);
		}
	} // End of processWindowEvent method.
/**
 * Method: 	main
 * <p>
 * Instantiate the registeredUser class.
 * </p>
 * @param	String args[]
 * @return	None
 * @throws	None
 */
	public static void main(String args[]) {
		registeredUser rU = new registeredUser();
		rU.setVisible(true);
	} // End of main method.
} // End of registereduser class.

/**
 * Class: 	ExitAction
 * <p>
 * Implement the exit menu option.
 * </p>
 * @param	None
 * @return	None
 * @throws	None
 */
class ExitAction extends AbstractAction {
	public ExitAction() {
		super("Exit");
	}
	public void actionPerformed(ActionEvent ev) {
	    System.exit(0);
	}
}
