import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.util.*;
import java.beans.*;
import java.io.*;

public class desktop extends JFrame {

private JDesktopPane desk;
private IconPolice iconPolice = new IconPolice();
public String selectedServer;
private final int MASTER = 1;
private final int WEBSERVER = 2;
private final int WEBFLOWSERVER = 3;
private final int GATEWAY =4;

public int n = 6;     //# parameters in MasterServerPanel
private String Display, ConfFile,IorFile,MyClassPath,servletURL,HashTableFile;

public int n_WS = 4;  //# parameters in WebServerPanel
public String WS_host, WS_port, WS_docroot, WS_servlets;

public int n_WF = 6;
public String RootHost, IORdir, IORfile, IORfileURL, WFconfDir, confFile;

private String[] conf;

  public desktop(String title) {
    desk = new JDesktopPane();
    setContentPane(desk);

    desk.setDesktopManager(new DesktopMgr());
    createMenuBar();
    loadBackgroundImage();

    /* default Server? */
   String dFileName = "defaultServer.txt";
   File dServer = new File(dFileName);
   if(dServer.exists()) {
     try {
        FileReader fr = new FileReader(dServer);
        BufferedReader in = new BufferedReader(fr);
        selectedServer = in.readLine();
        in.close();
     }
     catch (Exception e) {System.out.println(e+" while reading "+dFileName);}
     readConfigFile(selectedServer+".conf",n,MASTER); 
     readConfigFile(selectedServer+"WS.conf",n_WS,WEBSERVER); 
     readConfigFile(selectedServer+"WF.conf",n_WF,WEBFLOWSERVER); 
   }
  }

  protected void createMenuBar(){

    ActionListener fmbListener = new ActionListener() {
      public void actionPerformed(ActionEvent e) {
         System.exit(0);
      }
    };

    ActionListener cfgListener = new ActionListener() {
      public void actionPerformed(ActionEvent e) {
         String what = e.getActionCommand();
         if(what.equals("Select Server")) {
           getSelectedServer(); 
         } 
         if(what.equals("Configure Server")) {
           getServerConfig();
         } 
         if(what.equals("Status")) {
            TestServer();
         } 
      }
    };

    ActionListener moduleListener = new ActionListener() {
      public void actionPerformed(ActionEvent e) {
         String what = e.getActionCommand();
           getModule(what); 
      }
    };


    ActionListener applListener = new ActionListener() {
      public void actionPerformed(ActionEvent e) {
         String what = e.getActionCommand();
           runApplication(); 
      }
    };


    JMenuBar mb = new JMenuBar();

    JMenu FileMenu = new JMenu("File");
    JMenuItem exitItem = new JMenuItem("Exit");
    exitItem.addActionListener(fmbListener);     
    FileMenu.add(exitItem);

    JMenu ServerMenu = new JMenu("Server");
    JMenuItem selectItem = new JMenuItem("Select Server");
    JMenuItem cfgItem = new JMenuItem("Configure Server");
    JMenuItem statusItem = new JMenuItem("Status");
    selectItem.addActionListener(cfgListener);     
    cfgItem.addActionListener(cfgListener);     
    statusItem.addActionListener(cfgListener);     
    ServerMenu.add(selectItem);
    ServerMenu.add(cfgItem);
    ServerMenu.add(statusItem);

    JMenu ModuleMenu = new JMenu("Module Tester");
    JMenuItem testItem = new JMenuItem("Test");
    testItem.addActionListener(moduleListener);     
    ModuleMenu.add(testItem);

    JMenu ApplMenu = new JMenu("Application Tester");
    JMenuItem atestItem = new JMenuItem("Test");
    atestItem.addActionListener(applListener);     
    ApplMenu.add(atestItem);


    JMenu menu = new JMenu("XML");
    menu.add(new AddFrameAction("lo", "users", new Integer(3)));
    menu.add(new AddFrameAction("AAD", "application descriptors", new Integer (4)));
    menu.add(new TileAction(desk));
    setJMenuBar(mb);
    mb.add(FileMenu);
    mb.add(ServerMenu);
    mb.add(ModuleMenu);
    mb.add(ApplMenu);
    mb.add(menu);
  }

  protected void loadBackgroundImage() {
  ImageIcon icon = new ImageIcon("planet.jpg");
  JLabel l = new JLabel(icon);
  l.setBounds(0,0,icon.getIconWidth(),icon.getIconHeight());
  desk.add(l, new Integer(Integer.MIN_VALUE));
  }

  class AddFrameAction extends AbstractAction {
    public AddFrameAction(String name, String menuitem, Integer layer) {
    super(menuitem);
    this.name = name;
    this.layer= layer; 
    }

    public void actionPerformed(ActionEvent ev) {
      if(name.equals("AAD")){
        AADframe aad = new AADframe();
        aad.setBounds(0,0,500,500);
        desk.add(aad,layer);
      }
      else {
          JInternalFrame f = new JInternalFrame(name, true, true, true, true);
          f.addVetoableChangeListener(iconPolice);
          f.setBounds(0,0,200,300);
          desk.add(f,layer);
      }
    }

    private Integer layer;
    private String name;
  }

  class IconPolice implements VetoableChangeListener {
    public void vetoableChange(PropertyChangeEvent ev)
    throws PropertyVetoException {     
    
    String name = ev.getPropertyName();
    if(name.equals(JInternalFrame.IS_ICON_PROPERTY) &&
       (ev.getNewValue() == Boolean.TRUE)) {
      JInternalFrame[] frames = desk.getAllFrames();
      int count = frames.length;
      int nonicons = 0;
      for (int i=0; i<count; i++) {
        if(frames[i].isIcon() == false) {
           nonicons++;
	}
      }
      if (nonicons <= 1) {
        throw new PropertyVetoException("Invalid Iconification!", ev);
      }
    }
    }
  }               

  public void setSelectedServer(String s) {
    selectedServer = s;
    System.out.println("selectedServer: "+selectedServer);
  }

  public void getSelectedServer() {
    selectServer ss = new selectServer(this);
    ss.setBounds(0,0,200,200);
    desk.add(ss, new Integer(3)); 
  }

  public void setServerConfig(String[] s) {
   Display = s[0];
   ConfFile = s[1];
   IorFile = s[2];
   MyClassPath = s[3];
   servletURL = s[4];
   HashTableFile = s[5]; 
  }

  public void setWSConfig(String[] s) {
   WS_host = s[0];
   WS_port = s[1];
   WS_docroot = s[2];
   WS_servlets = s[3];
  }

  public void setWFConfig(String[] s) {
   RootHost = s[0];
   IORdir = s[1];
   IORfile = s[2];
   IORfileURL = s[3];
   WFconfDir = s[4];
   confFile = s[5];
  }

  public void getServerConfig() {
    ServerConfig sc = new ServerConfig(this);
    sc.setBounds(0,0,600,300);
    desk.add(sc, new Integer(3)); 
  }

  public void TestServer() {
    adminappl2 aa2 = new adminappl2(Display,ConfFile,IorFile,MyClassPath,
                                     servletURL,HashTableFile);
    aa2.setBounds(0,0,600,200);
    desk.add(aa2, new Integer(3)); 
  }

  public void readConfigFile(String FileName,int n, int what){ 
    File ConfFile = new File(FileName);  
    if(ConfFile.exists()) {
       conf = new String[n];
         try {
           FileReader fr = new FileReader(FileName);
           BufferedReader in = new BufferedReader(fr);
           String nextline = in.readLine();
           in.close();
           StringTokenizer st = new StringTokenizer(nextline,"+");

           for(int i=0; i<n; i++) {
           conf[i] = st.nextToken();
         }
      
         if(what == 1) setServerConfig(conf);
         if(what == 2) setWSConfig(conf);
         if(what == 3) setWFConfig(conf);
	 }
       catch (Exception e) {System.out.println(e);}      
    }
  }

  public void getModule(String moduleName) {
    LoadModule lm = new LoadModule(this);
    lm.setBounds(0,0,600,300);
    desk.add(lm, new Integer(3)); 
  }

  public void runApplication() {
    RunAppl ra = new RunAppl(this);
    ra.setBounds(0,0,600,500);
    desk.add(ra, new Integer(3)); 
  }

  public static void main(String[] args) {
    desktop td = new desktop("My desktop");
    td.setSize(700,600);
    td.setVisible(true);
  }
}





