package WebFlow;
import WebFlow.event.*;
import org.omg.CORBA.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.util.*;

import WebFlow.hashtable.*;
import WebFlow.ContextManager.*;
import WebFlow.RemoteFile.*;
import WebFlow.submitJob.*;
import WebFlow.FB.*;
import WebFlow.xml.*;

public class ClientModules {
    //
    // Standalone program initialization
    //
    public static void main(String args[])
    {
        configReader config;
      
	try
	{
          
	    // Create ORB 
         Properties props = System.getProperties();
         props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
         props.put("org.omg.CORBA.ORBSingletonClass", "com.ooc.CORBA.ORBSingleton");
            System.setProperties(props);

            ORB orb = ORB.init(args, props);

	    // Connect to the master server
	    

            String masterURL = args[0];
	    String ref;
	    org.omg.CORBA.Object obj=null;
	    boolean flag=true;
	    while(flag){

    //	      ref = getIORFromURL(masterURL);
	      ref = getIORFromFile(masterURL);
              System.out.println(ref);
	      obj = orb.string_to_object(ref);
	      boolean non_exist = true;
	      try{
		non_exist = obj._non_existent();
	      }catch(org.omg.CORBA.COMM_FAILURE ex){}
	       catch(org.omg.CORBA.OBJECT_NOT_EXIST ex){}

	      if (!non_exist)
		flag = false;
              try{
		Thread.sleep(500);
	      }catch(InterruptedException ex){
	      }

	    }

	    if(obj == null)
		throw new RuntimeException();

	    WebFlowContext ws = WebFlowContextHelper.narrow(obj);

	    if(ws == null)
			throw new RuntimeException();
	    
	    System.out.println("Client: Connected to the Master Server");


	    // connect to the slave
	    /*

           WebFlowContext slave, subContext;

           slave = WebFlowContextHelper.narrow(ws.getContext("master_test/slave_test"));
           System.out.println("Client: Connected to the Slave Server");
           // create a subContext of the Slave context
           if(slave == null) System.out.println("slave is null!");
           System.out.println("create a subContext");
           org.omg.CORBA.Object sc = slave.addNewContext("subContext");

           // test existence of the subContext
	      boolean failure = true;
	      try{
		failure = sc._non_existent();
	      }catch(org.omg.CORBA.COMM_FAILURE ex){}
	       catch(org.omg.CORBA.OBJECT_NOT_EXIST ex){}
           System.out.println("Failure? "+failure);

           subContext = WebFlowContextHelper.narrow(sc);
           System.out.println("Client: SubContext created");
	    */

           org.omg.CORBA.Object m1,m2,m3,m4,m5,m6,m7; 

           
           System.out.println("attach ContextData"); 


           m1 = ws.addNewModule("ContextData");
      	   ContextData cd  = ContextDataHelper.narrow(m1);
           cd.test();

           System.out.println("attach SaveContext"); 

           m2 = ws.addNewModule("SaveContext");
      	   SaveContext sc  = SaveContextHelper.narrow(m2);
           sc.test();

           System.out.println("attach ContextManager"); 

           m3 = ws.addNewModule("ContextManager");
      	   ContextManager cm  = ContextManagerHelper.narrow(m3);
           cm.test();

           System.out.println("attach aad"); 

           m4 = ws.addNewModule("aad");
      	   XmlServer aad  = XmlServerHelper.narrow(m4);
           aad.test();

           System.out.println("attach RemoteFile"); 

           m5 = ws.addNewModule("RemoteFile");
      	   RemoteFile rf  = RemoteFileHelper.narrow(m5);
           rf.test();

           System.out.println("attach submitJob"); 

           m6 = ws.addNewModule("submit");
      	   submitJob sj  = submitJobHelper.narrow(m6);
           sj.test();

           System.out.println("attach FileBrowser"); 

           m7 = ws.addNewModule("FileBrowser");
      	   FBServer fb  = FBServerHelper.narrow(m7);
           fb.test();


	   // now exit gracefully
            




           try {
             ws.removeMyself();
           } catch (Exception e) {;}

	} catch (Exception e1) {System.out.println(e1);}
           System.out.println("TEST COMPLETED");
    }



  
    public static String  getIORFromURL(String url) {
	System.out.println("Slave WebFlow is getting IOR from url:"+url);
	String masterServerIOR="";
	String thisLine=null;
	//Open the URL for reading
      try {
        URL u = new URL(url);
        // now turn the URL into a DataInputStream
        try {
          DataInputStream theHTML = new DataInputStream(u.openStream());
          try {
            while ((thisLine = theHTML.readLine()) != null) {
              //System.out.println("configReader:getIORfromURL:line"+thisLine);
		  masterServerIOR += thisLine;
            } // while loop ends here
          }  // end try
          catch (Exception e) {
            System.out.println("configReader:getIORfromURL:"+e);
          }
        } // end try
        catch (Exception e) {
          System.out.println("configReader:getIORfromURL:"+e);
        }

      } // end try
      catch (MalformedURLException e) {
        System.out.println("configReader:getIORfromURL:"+url + " is not a parseable URL");
        System.out.println("configReader:getIORfromURL:"+e);
      }
      
      return masterServerIOR;
      
    }

    static public String getIORFromFile(String file_name)
    {
	String ref = null;
	try
	    {
		String refFile = file_name;
		java.io.BufferedReader in =
		    new java.io.BufferedReader(new FileReader(refFile));
		ref = in.readLine();
	    }
	catch(java.io.IOException ex)
	    {
		System.err.println("Can't read from " +
				   ex.getMessage() + "'");
		System.exit(1);
	    }
	return ref;
    }


}
