package WebFlow;

import WebFlow.*;
import WebFlow.event.*;
import WebFlow.ContextManager.*;
import WebFlow.FB.*;
import WebFlow.RemoteFile.*;
import WebFlow.submitJob.*;
import WebFlow.xml.*;

 
import org.omg.CORBA.*;
import java.io.*;
import java.util.*;


/**
//Each WebFlow server will initiate its own IR server.
//We will use IR in two place:
//1- When adapter got one event, it will get the IR id of incoming event through IR server
//2- When one proxy wants to forward one incoming request to real object, it will use
**/

public class ServerServlet implements Runnable {

  public static ORB orb ;
  static Hashtable cmRef;
  static Hashtable ucRef;
  static Hashtable fbRef;
  static Hashtable rfRef;
  static Hashtable sjRef;
  static Hashtable aadRef;
  String[] args;

  //    public static void main(String args[])
    public ServerServlet(String[] args)
    {

     if (args.length < 1){
	  System.err.println("Enter config file ");
	  System.exit(0);
     }

     this.args = args;
     cmRef = new Hashtable();
     ucRef = new Hashtable();
     fbRef = new Hashtable();
     sjRef = new Hashtable();
     rfRef = new Hashtable();
     aadRef = new Hashtable();
    }


    public void run() {

     System.err.println("start the WF thread...");
     String configFile = args[0];
     System.err.println("configFile="+configFile);
     File cf = new File(configFile);
     if(cf.exists()) System.out.println("file exists");
     else {
       System.out.println(configFile+" does not exist");
       return;
     } 

     try
	{

          System.err.println("set system properties for ORBacus"); 
          Properties props = System.getProperties();
	  props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
	  props.put("org.omg.CORBA.ORBSingletonClass", "com.ooc.CORBA.ORBSingleton");
	  System.setProperties(props);

          System.err.println("create ORB and BOA");  
            //
            // Create ORB and BOA
            //
            orb = ORB.init(args, props);
	    BOA boa = ((com.ooc.CORBA.ORB)orb).BOA_init(args, props);

            System.err.println("set concurrency model");


	    //
            // Set the concurrency model
            //
            com.ooc.CORBA.ORB.conc_model(
                com.ooc.CORBA.ORB.ConcModel.ConcModelThreaded);

            if(com.ooc.CORBA.BOA.conc_model() !=
               com.ooc.CORBA.BOA.ConcModel.ConcModelThreadPool)
            {
                com.ooc.CORBA.BOA.conc_model(
                    com.ooc.CORBA.BOA.ConcModel.ConcModelThreadPerRequest);
            }

            System.err.println("create delegate object");


	    //
	    // Create delegate object
	    //
	    
	     //start Interface Repository
             System.err.println("Start Interface Repository");
             Process intRep = startIntRep();
 

             System.err.println("Instantiate WebFlow Server");
	     org.omg.CORBA.Object  conn=null;
	     try{
		 conn = new WebFlowContextImpl(configFile, orb, boa, intRep);
	     }catch(WebFlow.NullPointerException e){
		    System.err.println("WebFlow Server: got exc.:"+e);
	     }
	     catch(PropertyVetoException e){
		    System.err.println("WebFlow Server: got exc.:"+e);
	     }
            
            if(conn==null) System.exit(0);         
	    System.err.println("Server: created WFServerImpl");
	    

	    //
	    // Run implementation
	    //

            System.err.println("run WebFlow server"); 
	    WebFlowContextImpl impl = (WebFlowContextImpl)conn;
	    System.err.println("GATEWAY SERVER:exist:"+impl.non_existent);
	    if (impl.non_existent) boa.impl_is_ready(null);
	    System.err.println("GATEWAY SERVER IS EXITING ....");

	    //System.exit(0);
	}
	catch(SystemException ex)
	{
	    System.err.println(ex.getMessage());
	    ex.printStackTrace();
	    System.exit(1);
	}
    }


    public static void setContextManager(String user, ContextManager cm) {
         System.out.println("setContextManager for user: "+user);
         System.out.println("cmID: "+cm.getObjectID()); 
         cmRef.put(user,cm);   
         Enumeration activeUsers = cmRef.keys();
	 while(activeUsers.hasMoreElements()) {
           System.out.println(activeUsers.nextElement());
	 }
         System.out.println("setContextManager done"); 
    }

    public static ContextManager getContextManager(String user) {
         if(cmRef==null) System.out.println("cmRef is null");
         else System.out.println("cmRef is OK");  
         Enumeration activeUsers = cmRef.keys();
	 while(activeUsers.hasMoreElements()) {
           System.out.println(activeUsers.nextElement());
	 }
         System.out.println("return ContextManager for "+user);
         return (ContextManager)cmRef.get(user);
    }           

    public static void setUserContext(String user, WebFlowContext uc) {
         System.out.println("setContextManager for user: "+user);
         System.out.println("cmID: "+uc.getObjectID()); 
         ucRef.put(user,uc);   
	 /*
         Enumeration activeUsers = ucRef.keys();
	 while(activeUsers.hasMoreElements()) {
           System.out.println(activeUsers.nextElement());
	 }
         System.out.println("setContextManager done");
	 */ 
    }

    public static WebFlowContext getUserContext(String user) {
         if(ucRef==null) System.out.println("ucRef is null");
         else System.out.println("ucRef is OK");  
         Enumeration activeUsers = ucRef.keys();
	 while(activeUsers.hasMoreElements()) {
           System.out.println(activeUsers.nextElement());
	 }
         System.out.println("return ContextManager for "+user);
         return (WebFlowContext)ucRef.get(user);
    }           

    public static void setFileBrowser(String user, FBServer fb) {
         fbRef.put(user,fb);   
    }

    public static FBServer getFileBrowser(String user) {
         if(fbRef==null) System.out.println("fbRef is null");
         else System.out.println("fbRef is OK");  
         Enumeration activeUsers = fbRef.keys();
	 while(activeUsers.hasMoreElements()) {
           System.out.println(activeUsers.nextElement());
	 }
         System.out.println("return FileBrowser for "+user);
         return (FBServer)fbRef.get(user);
    }           

    public static void setRemoteFile(String user, RemoteFile rf) {
         rfRef.put(user,rf);   
    }

    public static RemoteFile getRemoteFile(String user) {
         if(rfRef==null) System.out.println("rfRef is null");
         else System.out.println("rfRef is OK");  
         Enumeration activeUsers = rfRef.keys();
	 while(activeUsers.hasMoreElements()) {
           System.out.println(activeUsers.nextElement());
	 }
         System.out.println("return RemoteFile for "+user);
         return (RemoteFile)rfRef.get(user);
    }           

    public static void setSubmitJob(String user, submitJob sj) {
         sjRef.put(user,sj);   
    }

    public static submitJob getSubmitJob(String user) {
         if(sjRef==null) System.out.println("sjRef is null");
         else System.out.println("sjRef is OK");  
         Enumeration activeUsers = sjRef.keys();
	 while(activeUsers.hasMoreElements()) {
           System.out.println(activeUsers.nextElement());
	 }
         System.out.println("return FileBrowser for "+user);
         return (submitJob)sjRef.get(user);
    }           

    public static void setAAD(String user, XmlServer aad) {
         aadRef.put(user,aad);   
    }

    public static XmlServer getAAD(String user) {
         if(aadRef==null) System.out.println("aadRef is null");
         else System.out.println("aadRef is OK");  
         Enumeration activeUsers = aadRef.keys();
	 while(activeUsers.hasMoreElements()) {
           System.out.println(activeUsers.nextElement());
	 }
         System.out.println("return FileBrowser for "+user);
         return (XmlServer)aadRef.get(user);
    }           


public static Process startIntRep()
  {
	String ref=null ;
	printProcessOut ppo;
	org.omg.CORBA.Object IRobj=null;
	Process p=null;

	System.err.println("IR: start interface Repository");
	String command = "irserv --ior";
	try{
	 p = Runtime.getRuntime().exec(command);
	 ppo = new printProcessOut(p);
     
	 ref = ppo.getIOROfProcess();
	 //System.err.println("WebFlow server got IOR of IR:"+ref);
	 ppo.startProcess(); 
	}catch (Exception ex){
	System.err.println("IR: Error in starting ModuleFactory in Proxy:"+ex);
          System.exit(0);
	}

	IRobj = orb.string_to_object(ref);
	((com.ooc.CORBA.ORB)orb).add_initial_reference("InterfaceRepository", IRobj);
	System.err.println("IR: WebFlow server connected to IR");

	return p;
 }	


public  static org.omg.CORBA.Object readIOR(org.omg.CORBA.ORB orb ,String fn)
{
    String ref = null;
    try
      {
		String refFile = fn;//"Hello.ref";
		FileInputStream file = new FileInputStream(refFile);
		BufferedReader in =
		new BufferedReader(new InputStreamReader(file));
		ref = in.readLine();
		file.close();
      }
    catch(IOException ex)
      {
            System.err.println("Can't read from `" +
                                   ex.getMessage() + "'");
			System.exit(1);
      }
 
    org.omg.CORBA.Object obj = orb.string_to_object(ref);
    return obj;
        
  }



}


