package WebFlow.Servlets;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import WebFlow.Base64.*;
import WebFlow.*;
import WebFlow.event.*;
import WebFlow.ContextManager.*;
import org.omg.CORBA.*;
import java.util.*;
import java.text.*;

public class Form21 extends HttpServlet{

	ServletOutputStream out;
	ContextManager cm;
	private String userName; 
	private String option;
	private String problemName;

	public void doGet(HttpServletRequest req, HttpServletResponse res)
                       throws ServletException, IOException {

        String auth = req.getHeader("authorization");
        StringTokenizer st = new StringTokenizer(auth);
        String copa = st.nextToken();
        copa = st.nextToken();
        Base64Decoder decoder = new Base64Decoder(copa);
        try {
          String decoded = decoder.processString();
          StringTokenizer st1 = new StringTokenizer(decoded,":");
          userName = st1.nextToken();
        } catch (Exception e) {
          System.err.println("cannot decode "+copa);
          System.err.println(e);
        } 

  cm = ServerServlet.getContextManager(userName);  
  option = req.getParameter("option");
  problemName = req.getParameter("ProjectContextName"); 

  out = res.getOutputStream();
  res.setContentType("text/html");

  if(option.equals("new")) createProblem();
  if(option.equals("select")) selectProblem(problemName);
  if(option.equals("delete")) deleteProblem(problemName);
  if(option.equals("list")) listProblems();
  if(option.equals("create")) createNewProblem(problemName);
  if(option.equals("set property")) {
      String pname=req.getParameter("pname");
      String pvalue=req.getParameter("pvalue"); 
      System.out.println(pname+"="+pvalue);  
      setProperty(problemName,pname,pvalue);
  }
  out.println("</BODY>");    
  out.println("</HTML>");

  out.flush();
  out.close();

  }

  public void createProblem() {

      /* just ask the user for the problem name */

    printHead("Create a New Problem");
    printHelpForm();

    prnt("<P><B>Type a name of the new problem</B>\n</P>");

    prnt("<DIV>");          
    printFormTag("Form21");
    prnt("<CENTER>");
    prnt("<INPUT TYPE=\"text\" NAME=\"ProjectContextName\" SIZE=40>");
    prnt("<P>");
    prnt("<INPUT TYPE=\"submit\" NAME=\"option\" VALUE=\"create\">");
    prnt("</CENTER>"); 
    prnt("</FORM>");
    prnt("<DIV>");          
  }

  public void selectProblem(String problemName) {

      /* user already selected the problem
         find it, list its properties, 
         and allow for setting a new property
         This is an example of how to use ContextManager
      */

    cm.setCurrentProblem(problemName); 
    String start=cm.getCurrentProblemProperty("Date");     
    String lastt=cm.getCurrentProblemProperty("LastTime");     

    printHead("SetProblemProperties");
    printHelpForm();
    prnt("<P><B>You selected problem "+problemName+" </B>\n</P>");
    prnt("<p><center>Properties:"); 
    prnt("<table>");
    prnt("<td>Creation Time</td>");
    prnt("<td>"+formatDate(start)+"<td><tr>"); 
    prnt("<td>Last Modified</td>");
    prnt("<td>"+formatDate(lastt)+"<td><tr>"); 
    prnt("<td>MyValue</td>");
    prnt("<td>"+cm.getCurrentProblemProperty("MyValue")+"<td><tr>"); 
    prnt("</table></p>");

    prnt("<P><B>Set a new value of property MyValue:</B>\n</P>");

    prnt("<DIV>");          
    printFormTag("Form21");
    prnt("<CENTER>");
    prnt("<INPUT TYPE=\"hidden\" NAME=\"ProjectContextName\" VALUE=\""+problemName+"\">"); 
    prnt("<INPUT TYPE=\"hidden\" NAME=\"pname\" VALUE=\"MyValue\">"); 
    prnt("<INPUT TYPE=\"text\" NAME=\"pvalue\" SIZE=40>");
    prnt("<P>");
    prnt("<INPUT TYPE=\"submit\" NAME=\"option\" VALUE=\"set property\">");
    prnt("</CENTER>"); 
    prnt("</FORM>");
    prnt("<DIV>");      
  }

  public void deleteProblem(String problemName) {

      /* find the problem, delete it, and return to listProblems */ 
     boolean status = cm.removeProblem(problemName);
     if(status) listProblems();
     else ErrorMessage("cannot delete "+problemName);   
  }

  public void createNewProblem(String problemName) {

      /* create a new context and return to listProblems */ 
     boolean status = cm.addProblem(problemName);
      if(status) listProblems(); 
      else ErrorMessage("cannot create "+problemName);  
  }

  public void setProperty(String problemName, String pname, String pvalue) {
 
     System.out.println("start setProperty");
     System.out.println("problem="+problemName);  
     boolean status = cm.setCurrentProblem(problemName);
      if(!status) ErrorMessage("cannot find "+problemName);
      else {
        System.out.println("set property "+pname+" to "+pvalue);
        status=cm.setCurrentProblemProperty(pname,pvalue);
         System.out.println("status="+status);
        if(status) selectProblem(problemName);
        else ErrorMessage("cannot set value of "+pname+" to "+pvalue);
      }    
  }

  public void listProblems() {
     printHead("List of Exisitng Problems");
     printHelpForm();  
     prnt("<P><B>Select an existing problem description from the list below;</B>");
     prnt("<B>or create a new problem description (by clicking the new button).</B>\n</P>");

     prnt("<DIV>");
     printFormTag("Form21");

     String[] lp = cm.listProblems();
     int nc = lp.length;

     if(nc>0) {
      for(int i=0; i<nc; i++) {
        String aName = lp[i];
        prnt("<BR>"); 
        prnt("<INPUT TYPE=\"radio\" NAME=\"ProjectContextName\" VALUE=\""+lp[i]+"\"> "+aName);
      }
     }
     else {
       prnt("<P ALIGN=\"center\">");
       prnt ("There are no existing problem descriptions defined.<BR>");
       prnt("Please use \"new\" button to create one"); 
       prnt("</P>");
     }
     prnt("<P><CENTER>");
     prnt("<INPUT TYPE=\"submit\" NAME=\"option\" VALUE=\"new\">");
     prnt("<INPUT TYPE=\"submit\" NAME=\"option\" VALUE=\"select\">");
     prnt("<INPUT TYPE=\"submit\" NAME=\"option\" VALUE=\"delete\">");
     prnt("<INPUT TYPE=\"button\" NAME=\"submit\" VALUE=\"archive\" onClick=\"alert(\'not supported\')\">");

     prnt("</CENTER>"); 
  }

    public void ErrorMessage(String msg){
      printHead("Error"); 
      prnt("<h1><font color=\"red\">");
      prnt(msg);
      prnt("</font></h1>"); 
    }

  public void printHead(String title) {
    prnt("<html>");
    prnt("<TITLE>");
    prnt(title);
    prnt("\t</TITLE>");
    prnt("</HEAD>");
    prnt("<BODY STYLE=\"color:black;\" BGCOLOR=\"#f2fae4\" BACKGROUND=\"/SciPortal/ccmImages/bg1x.jpg\">");
    prnt("<H1 ALIGN=\"center\">"+title+"</H1>");
  }

  public void printHelpForm(){
    prnt("<DIV ALIGN=\"right\">");
    prnt("<FORM NAME=\"helpform\">");
    prnt("<INPUT TYPE=\"button\" NAME=\"submit\" VALUE=\"help\" onClick=showHelp(\"\")>");
    prnt("</FORM>");
    prnt("</DIV>");
    }

    public void printFormTag(String ServletName){
      String formName="testform";
      String method="GET";
      String form = "<FORM NAME=\""+formName+"\"";
      form += "METHOD=\""+method+"\""; 
      form += "ACTION=\"/SciPortal/servlet/WebFlow.Servlets.";
      form +=  ServletName+"\">";
      prnt(form);
    }

  public void prnt(String msg){
    try{
      out.println(msg);
    } catch (Exception e){System.out.println(e);}
  }

    public String formatDate(String d){
      Date dateD=null;
      long dateL;
      SimpleDateFormat formatter = new SimpleDateFormat("s",Locale.getDefault());
      try {
      dateL = (new Long(d)).longValue();
      dateD = new Date(dateL);
      formatter.applyPattern("yyyy-MMM-d HH:mm:ss");
      } catch (Exception e) {System.out.println(e);}
      String dateS = formatter.format(dateD);
      return dateS;  
    }

  public String getServletInfo(){
    return "By T. Haupt and K. Flurchick";
  }

}



