package ccm.at;

import java.util.Vector;

import org.xml.sax.XMLReader;
import org.xml.sax.Attributes;
import org.xml.sax.InputSource;
import org.xml.sax.helpers.DefaultHandler;
import org.apache.xerces.parsers.SAXParser;
import org.xml.sax.ErrorHandler;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

public class ProblemListBean extends DefaultHandler
{
  private String userName;
  private String usersDir;
  private Vector problemNames = null;
  private String problemName;

  private String templateName = "problemName";
  private String elementName = "";
  //private Vector vec = null;
  
  public ProblemListBean () {
    super();
    userName = "";
    usersDir = "";
    //problemNames = new String[] { "0", "1" };
    problemNames = new Vector();
    problemName = ""; 
    //vec = new Vector();
  }

  public String getUserName() {
    return userName;
  }

  public void setUserName(String userName) {
    this.userName = userName;
  }

  public String getUsersDir() 
  {
    return usersDir;
  }

  public void setUsersDir(String usersDir) 
  {
    this.usersDir = usersDir;
  }
   
  public Vector getProblemNames() throws Exception
  {
    XMLReader xr = new SAXParser();
    //ProblemListBean handler = new ProblemListBean();
    xr.setContentHandler(this);
    xr.setErrorHandler(this);
    xr.setFeature("http://xml.org/sax/features/validation", true);
    xr.setFeature("http://xml.org/sax/features/namespaces", false);
    xr.setFeature("http://xml.org/sax/features/namespace-prefixes", false);
    String XMLfile = usersDir + "/" + userName + "/" + userName + 
                     ".xml";
    xr.parse(new InputSource(XMLfile));
    return problemNames;
    /* 
    for (int i = 0; i < vec.size(); i++)
    {
      problemNames[i] = ((String)vec.get(i)).trim();
    }
      return problemNames;
    */
  }

    public void startElement(String uri, String name,
    String qName, Attributes atts)
  {
    elementName = qName;
  }

  public void characters(char ch[], int start, int length)
  {
    if (elementName.equals(templateName))
    {
      String pName = new String(ch, start, length);
      problemNames.add(pName);
    }
  }

  public void warning(SAXParseException ex)
  {
    System.err.println("[Warning] "+
                       getLocationString(ex)+": "+
                       ex.getMessage());
  }

  /** Error. */
  public void error(SAXParseException ex)
  {
    System.err.println("[Error] "+
                       getLocationString(ex)+": "+
                       ex.getMessage());
  }

  /** Fatal error. */
  public void fatalError(SAXParseException ex)
    throws SAXException
  {
    System.err.println("[Fatal Error] "+
                       getLocationString(ex)+": "+
                       ex.getMessage());
    throw ex;
  }
  /** Returns a string of the location. */
  private String getLocationString(SAXParseException ex)
  {
    StringBuffer str = new StringBuffer();

    String systemId = ex.getSystemId();
    if (systemId != null)
    {
      int index = systemId.lastIndexOf('/');
      if (index != -1)
        systemId = systemId.substring(index + 1);
      str.append(systemId);
    }
    str.append(':');
    str.append(ex.getLineNumber());
    str.append(':');
    str.append(ex.getColumnNumber());

    return str.toString();
  } // getLocationString(SAXParseException):String
}
