package ccm.pdt;
/**
 * @(#) EntryBean.java
 * @author  Tom Haupt and Ken Flurchick
 * Date:    05/17/2000
 * Purpose: Bean for the entry page of the
 *          Problem Description Toolkit.
 *
 * Required Classes: WebFlow Package
 */
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import WebFlow.*;
import WebFlow.event.*;
import WebFlow.ContextManager.*;
import org.omg.CORBA.*;
import java.util.*;
import java.text.*;
import entry.*;
import ccm.entry.*;
/**
 * Class: EntryBean
 * <p>
 * This class will process the pdt options.  May be 
 * broken into different classes for different forms.
 * </p>
 * @param  None
 * @return None
 * @throws None
 */
public class EntryBean{
  ServletOutputStream out;
  ContextManager cm;
  private String option;
  private String user;
  private String problemName;
  private String track;
  private String[] lp;
  String documentRoot = "";

  public void EntryBean(){
    // Empty constructor.
  }
// Setter methods for the Bean.
  public void setDocumentRoot(String S){
    this.documentRoot = S;
  }
  public void setUser(String S){
    this.user = S;
  }
  public void setOption(String S){
    this.option = S;
  }
// Getter methods for the Bean.
  public String getDocumentRoot(){
    return documentRoot;
  }
  public String getOption(){
    return option;
  }
  public String[] getLp(){
    return lp;
  }
/**
 * Method: parseOption
 * <p>
 * Parse on the options
 * </p>
 * <ol type="I">
 *   <li>"select" retrieve the existing context data.
 *   <li>"list" list the problem contexts.
 * </ol>
 * @param  String option
 * @return None
 * @throws None
 */
  public void parseOption(String option){
    System.out.println("....parse option...: " + option 
      + " for " + user);
    cm = ServerServlet.getContextManager(user);  
    if(option.equals("select")) selectProblem(problemName);
    if(option.equals("list")) 	listProblems();
  }
/**
 * Method: selectProblem
 * <p>
 * The user has selected a problem:
 * </p>
 * <ol type="i">
 *   <li>find it 
 *   <li>list its properties 
 *   <li>and allow for setting a new property
 * </ol>
 * <p>
 * This is an example of how to use the ContextManager.
 * </p>
 * @param  String problemName
 * @return None
 * @throws None
 */
  public void selectProblem(String problemName) {
    cm.setCurrentProblem(problemName); 
    String start=cm.getCurrentProblemProperty("Date");     
    String lastt=cm.getCurrentProblemProperty("LastTime");     
  }
/**
 * Method: listProblems
 * @param  None
 * @return String pdNames
 * @throws None
 */
  public void listProblems() {
    lp = cm.listProblems();
    System.out.println("lp = " + lp.length);
    if(cm == null){
      lp[0] = "Error accessing CM";
      lp[1] = "Error Error Error"; 
    }
  }
/**
 * Method: getBeanInfo
 * @param  None
 * @return None
 * @throws None
 */
  public String getBeanInfo(){
    return "By K. Flurchick and T. Haupt";
  }
}
