package Toolkits.Servlets;

/**
 * @(#) pdtServlet.java
 * @author      Tom Haupt and Ken Flurchick
 * Date:        05/17/2000
 * Purpose:     Entry page into the Problem Description Toolkit.
 *
 * Required Classes:
 *		WebFlow Package
 */
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import WebFlow.Base64.*;
import WebFlow.*;
import WebFlow.event.*;
import WebFlow.ContextManager.*;
import org.omg.CORBA.*;
import java.util.*;
import java.text.*;
/**
 * Class: pdtServlet
 * <p>
 * </p>
 * @param       None
 * @return      None
 * @throws      None
 */
public class pdtServlet extends HttpServlet{

	ServletOutputStream out;
	ContextManager cm;
	private String userName; 
	private String option;
	private String problemName;
	private String track;
/**
 * Method: doGet
 * <p>
 * </p>
 * @param       HttpServletRequest req
 * @param	HttpServletResponse res
 * @return      None
 * @throws      ServletException
 * @throws	IOException
 */
	public void doGet(HttpServletRequest req, HttpServletResponse res)
                       throws ServletException, IOException {
/**
 * Get the user name
 */
        	String auth = req.getHeader("authorization");
        	StringTokenizer st = new StringTokenizer(auth);
        	String copa = st.nextToken();
        	copa = st.nextToken();
        	Base64Decoder decoder = new Base64Decoder(copa);
        	try {
          		String decoded = decoder.processString();
          		StringTokenizer st1 = new StringTokenizer(decoded,":");
          		userName = st1.nextToken();
        	} catch (Exception e) {
          		System.err.println("cannot decode "+copa);
          		System.err.println(e);
        	} 
/**
 * Set up the paramaters from the HTTPrequest
 */
		cm = ServerServlet.getContextManager(userName);  
		option = req.getParameter("option");
		problemName = req.getParameter("ProjectContextName"); 
		track = req.getParameter("track");

		out = res.getOutputStream();
		res.setContentType("text/html");
/**
 * Parse on the options
 * <ol type="I">
 * 	<li>"new" returns page to get the name of the problem and then invokes 
 *		<em>createNewProblem</em> via "create" optionto add this to the 
 *		context data.
 *	<li>"select" retrieve the existing context data.
 * 	<li>"list" list the problem contexts.
 * 	<li>"set property" invokes the <em>setProperty</em> method." 
 * </ol>
 */
		if(option.equals("new")) 	createProblem();
		if(option.equals("select")) 	selectProblem(problemName);
		if(option.equals("delete")) 	deleteProblem(problemName);
		if(option.equals("list")) 	listProblems();
		if(option.equals("create")) 	createNewProblem(problemName);
		if(option.equals("set property")) {
			String pname=req.getParameter("pname");
			String pvalue=req.getParameter("pvalue"); 
			System.out.println(pname+"="+pvalue);  
			setProperty(problemName,pname,pvalue);
		}
		out.println("</body>");    
		out.println("</html>");
		out.flush();
		out.close();
	}
/**
 * Method: createProblem
 * <p>
 * </p>
 * @param       None
 * @return      None
 * @throws      None
 */
	public void createProblem() {
/**
 * Write the html page header.
 * Then write the help link.
 */
		printHead("Create a New Problem");
		printHelpForm("createHelp");
/**
 * Begin the specific page body.
 */
		prnt("<p>\n<strong>Type a name of the new problem</strong>\n</p>");
		prnt("<table align=\"center\">\n<tr>");          
		printFormTag("pdtServlet");
		prnt("\t<td colspan=\"2\">");
		prnt("\t\t<input type=\"text\" name=\"ProjectContextName\" size=\"40\">");
		prnt("\t</td>\n</tr><tr>\n\t<td align=\"left\">");
		prnt("\t\t<input type=\"submit\" name=\"option\" value=\"create\">");
		prnt("\t</td><td align=\"left\">");
		prnt("\t\t<label for=\"User\"><strong>&nbsp;User Track&nbsp;</strong></label>");
		prnt("\t\t<input id=\"User\" type=\"radio\" name=\"track\" value=\"true\" checked>");
		prnt("\t\t<label for=\"Advanced\"><strong>&nbsp;Advanced Track&nbsp;</strong></label>");
		mrnt("\t\t<input id=\"Advanced\" type=\"radio\" name=\"track\" value=\"false\">");
		prnt("\t</td>\n</tr>\n</table>");
		prnt("</form>");
		prnt("</div>");          
	}
/**
 * Method: selectProblem
 * <p>
 * The user has selected a problem:
 * </p>
 * <ol type="i">
 * 	<li>find it 
 *	<li>list its properties 
 * 	<li>and allow for setting a new property
 * </ol>
 * <p>
 * This is an example of how to use the ContextManager.
 * </p>
 * @param       String problemName
 * @return      None
 * @throws      None
 */
	public void selectProblem(String problemName) {
		cm.setCurrentProblem(problemName); 
		String start=cm.getCurrentProblemProperty("Date");     
		String lastt=cm.getCurrentProblemProperty("LastTime");     

		printHead("SetProblemProperties");
		printHelpForm("propertiesHelp");
		prnt("<p>\n<strong>You selected problem "+problemName+" </strong>\n</p>");
		prnt("<p align=\"center\">Properties:\n"); 
		prnt("<table>");
		prnt("<td>Creation Time</td>");
		prnt("<td>"+formatDate(start)+"<td><tr>"); 
		prnt("<td>Last Modified</td>");
		prnt("<td>"+formatDate(lastt)+"<td><tr>"); 
		prnt("<td>MyValue</td>");
		prnt("<td>"+cm.getCurrentProblemProperty("MyValue")+"<td><tr>"); 
		prnt("</table>");

		prnt("<p><strong>Set a new value of property MyValue:</strong>\n</p>");

		prnt("<div align=\"center\">");          
		printFormTag("pdtServlet");
		prnt("<input type=\"hidden\" name=\"ProjectContextName\" value=\"" 
			+ problemName + "\">"); 
		prnt("<input type=\"hidden\" name=\"pname\" value=\"MyValue\">"); 
		prnt("<input type=\"text\" name=\"pvalue\" size=\"40\">");
		prnt("<p>");
		prnt("<input type=\"submit\" name=\"option\" value=\"set property\">");
		prnt("</form>");
		prnt("</div>");      
	}
/**
 * Method: deleteProblem
 * <p>
 * find the problem, delete it, and return to listProblems
 * </p>
 * @param       String problemName
 * @return      None
 * @throws      None
 */
	public void deleteProblem(String problemName) {
		boolean status = cm.removeProblem(problemName);
		if(status) listProblems();
			else ErrorMessage("cannot delete "+problemName);   
	}
/**
 * Method: createNewProblem
 * <p>
 * create a new context and return to listProblems
 * </p>
 * @param       String problemName
 * @return      None
 * @throws      None
 */
	public void createNewProblem(String problemName) {
		boolean status = cm.addProblem(problemName);
		// KMF if(status) listProblems(); 
		if(status && (track.equals("true"))) {
			trackUser();
		} else if(status && (track.equals("false"))) {
			trackAdv();
		} else ErrorMessage("cannot create " + problemName);  
	}
/**
 * Method: setProperty
 * <p>
 * This method allows the user to write name/value pairs into the persistant context
 * data assuming the current problem context.  That is, this method sets the named 
 * property of the current context to value. Returns false if the current context is 
 * null.  The semantic of these method is identical to that of <em>setSessionData</em> 
 * and the data are stored persistently. 
 * <br>public boolean setCurrentProblemProperty(String name, String value); 
 * </p>
 * @param       String problemName
 * @param	String pname
 * @param	String pvalue
 * @return      None
 * @throws      None
 */
	public void setProperty(String problemName, String pname, String pvalue) {
		System.out.println("start setProperty");
		System.out.println("problem=" + problemName);  
		boolean status = cm.setCurrentProblem(problemName);
		if(!status) ErrorMessage("cannot find " + problemName);
		else {
			System.out.println("set property " + pname + " to " + pvalue);
			status=cm.setCurrentProblemProperty(pname,pvalue);
			System.out.println("status=" + status);
			if(status) selectProblem(problemName);
			else ErrorMessage("cannot set value of " + pname + " to " + pvalue);
		}    
	}
/**
 * Method: listProblems
 * <p>
 * </p>
 * @param       None
 * @return      None
 * @throws      None
 */
	public void listProblems() {
		printHead("List of Exisitng Problems");
		printHelpForm("createHelp");  
		prnt("<p>\n\nproblemName = " + problemName
                                + "\n\noption = " + option
                                + "\n\ntrack = " + track
                                + "\n\n</p>");
		prnt("<p>\n<strong>Select an existing problem description from the list below;</strong>");
		prnt("<strong>or create a new problem description (by clicking the new button).</strong>\n</p>");
		
		prnt("<br>");
		printFormTag("pdtServlet");

		String[] lp = cm.listProblems();
		int nc = lp.length;

		if(nc > 0) {
			for(int i = 0; i < nc; i++) {
				String aName = lp[i];
				prnt("<br>"); 
				prnt("<input type=\"radio\" name=\"ProjectContextName\" value=\""
					+ lp[i] + "\"> " + aName);
			}
		} else {
 			prnt("<p align=\"center\">");
 			prnt ("There are no existing problem descriptions defined.");
   			prnt("<br>Please use \"new\" button to create one"); 
   			prnt("</p>");
 		}
 		prnt("<p align=\"center\">");
 		prnt("<input type=\"submit\" name=\"option\" value=\"new\">");
 		prnt("<input type=\"submit\" name=\"option\" value=\"select\">");
		prnt("<input type=\"submit\" name=\"option\" value=\"delete\">");
     		prnt("<input type=\"button\" name=\"submit\" value=\"archive\" onClick=\"alert(\'not supported\')\">");
		prnt("</p>\n</form>");
	}
/**
 * Method: trackUser
 * <p>
 * </p>
 * @param       None
 * @return      None
 * @throws      None
 */
	public void trackUser(){
		prnt("Called trackUser");
	}
/**
 * Method: trackAdv
 * <p>
 * </p>
 * @param       None
 * @return      None
 * @throws      None
 */
	public void trackAdv(){
		prnt("Called trackAdv");
	}
/**
 * ============================================================================================================
 * ============================================================================================================
 */
/**
 * Method: ErrorMessage
 * <p>
 * Flag the user that some (known) error has occurred.
 * </p>
 * @param       String msg
 * @return      None
 * @throws      None
 */
	public void ErrorMessage(String msg){
		printHead("Error"); 
		prnt("<h1><span style\"color:red;\">");
		prnt(msg);
		prnt("</span></h1>"); 
	}
/**
 * Method: printHead
 * <p>
 * This method writes the standard header for the SciPortal pages.
 * </p>
 * <ol type="i">
 *	<li>Page title is passed as an argument.
 *	<li>Style sheet is -- /SciPortal/styles/standard.css
 *	<li>Javascript is -- /SciPortal/js/standard.js
 *	<li>Body style is -- style="color:black;" bgcolor="#f2fae4" background="/SciPortal/ccmImages/bg1x.jpg"
 * </ol>
 * @param       String title
 * @return      None
 * @throws      None
 */
	public void printHead(String title) {
		prnt("<html>");
		prnt("<head>");
		prnt("\t<link type=\"text/css\" rel=\"stylesheet\" href=\"/SciPortal/styles/standard.css\">");
		prnt("\t<script language=\"javascript\" src=\"/SciPortal/js/standard.js\"></script>");
		prnt("\t<title>");
		String ttTitle = "\t\t" + title;
		prnt(ttTitle);
		prnt("\t</title>");
		prnt("</head>");
		prnt("<body style=\"color:black;\" bgcolor=\"#f2fae4\" background=\"/SciPortal/ccmImages/bg1x.jpg\">");
		prnt("<h1 align=\"center\">"+title+"</h1>");
	}
/**
 * Method: printHelpForm
 * <p>
 * This method writes the help button on the right of the page.  
 * The location of the help file is passed as an argument.
 * </p>
 * @param	String helpURL
 * @return	None
 * @throws	None
 */
	public void printHelpForm(String helpURL){
		prnt("<div align=\"right\">");
		prnt("<form name=\"helpform\">");
		prnt("\t<input type=\"button\" name=\"submit\" value=\"help\" onClick=showHelp(\""
			+ "http://heechee.osc.edu/SciPortal/ccmPdt/" + helpURL + "\")>");
		prnt("</form>");
		prnt("</div>");
	}
/**
 * Method: printFormTag
 * <p>
 * This method writes the form tag including the action.
 * The action of the form (<em>ServletName</em> is passed as an argument.
 * </p>
 * @param       String ServletName
 * @return      None
 * @throws      None
 */
	public void printFormTag(String ServletName){
		String formName="testform ";
		String method="GET ";
		String form = "<form name=\"" + formName + "\"";
		form += "method=\"" + method + "\""; 
		form += "action=\"/SciPortal/servlet/Toolkits.Servlets.";
		form +=  ServletName+"\">";
		prnt(form);
	}
/**
 * Method: prnt
 * <p>
 * This method writes the specified string.
 * The try-catch is here for an IOexception.
 * </p>
 * @param       String msg
 * @return      None
 * @throws      None
 */
	public void prnt(String msg){
		try{
			out.println(msg);
		} catch (Exception e){
			System.out.println(e);
		}
	}
/**
 * Method: formatDate
 * <p>
 * This method formats and writes the date.
 * The date is passed as an argument.
 * This is used for the date as it is stored in the context data.
 * </p>
 * @param       String d
 * @return      String dateS
 * @throws      None
 */
	public String formatDate(String d){
		Date dateD=null;
		long dateL;
		SimpleDateFormat formatter = new SimpleDateFormat("s",Locale.getDefault());
		try {
			dateL = (new Long(d)).longValue();
			dateD = new Date(dateL);
			formatter.applyPattern("yyyy-MMM-d HH:mm:ss");
		} catch (Exception e) {
			System.out.println(e);
		}
		String dateS = formatter.format(dateD);
		return dateS;  
	}
/**
 * Method: getServletInfo
 * <p>
 * </p>
 * @param       None
 * @return      None
 * @throws      None
 */
	public String getServletInfo(){
		return "By T. Haupt and K. Flurchick";
	}
}
