package ccm.test;

/* Stollen, (then modified by jkl) from: James Goodwill, "Developing
 * Java Servlets", SAMS Publishing, Indianapolis 1999, page 42
 */

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

public class formInputTest extends HttpServlet {

    public void init(ServletConfig config) throws ServletException {
	super.init(config);
    }

    public void doGet(HttpServletRequest request, HttpServletResponse response)
	throws ServletException, IOException {
	doPost(request, response);
    }


    public void doPost(HttpServletRequest request,
		       HttpServletResponse response)
	throws ServletException, IOException {

	response.setContentType("text/html");
	PrintWriter out = response.getWriter();
	out.println("<HTML>");
	out.println("<HEAD><TITLE>Dump FORM data</TITLE></HEAD>");
	out.println("<BODY BGCOLOR=\"yellow\">");

	// Get parameter names
	Enumeration parameters = request.getParameterNames();
	String param = null;

	// Iterate over names and print values from the FORM
	out.println("<H1>Name and Value pairs from the FORM</H1><BR>");
	while (parameters.hasMoreElements() ) {
	    param = (String)parameters.nextElement();
	    out.println("<B>" + param + "</B> : " +
			request.getParameter(param) + "<BR>");
	}

	// Retrive Environment Variables
	out.println("<BR><BR>");
	out.println("<H1>Environment Variables from CGI Interface</H1><BR>");
	out.println("<B>SERVER_NAME</B> : "+request.getServerName()+"<BR>");
	out.println("<B>SERVER_SOFTWARE</B> : "+
		    getServletContext().getServerInfo()+"<BR>");
	out.println("<B>Real Path of /</B> : "+
		    getServletContext().getRealPath("/")+"<BR>");

	out.println("<B>req.getContextPath()</B> : "+request.getContextPath()+"<BR>");
	out.println("<B>req.getRequestURI()</B> : "+request.getRequestURI()+"<BR>");
	out.println("<B>SERVER_PROTOCOL</B> : "+request.getProtocol()+"<BR>");
	out.println("<B>Get Scheme</B> : "+request.getScheme()+"<BR>");

	out.println("<B>SERVER_PORT</B> : "+request.getServerPort()+"<BR>");
	out.println("<B>REQUEST_METHOD</B> : "+request.getMethod()+"<BR>");
	out.println("<B>PATH_INFO</B> : "+request.getPathInfo()+"<BR>");
	out.println("<B>PATH_TRANSLATED</B> : "+
		    request.getPathTranslated()+"<BR>");
	out.println("<B>SCRIPT_NAME</B> : "+request.getServletPath()+"<BR>");
	out.println("<B>QUERY_STRING</B> : "+request.getQueryString()+"<BR>");
	out.println("<B>REMOTE_HOST</B> : "+request.getRemoteHost()+"<BR>");
	out.println("<B>REMOTE_ADDR</B> : "+request.getRemoteAddr()+"<BR>");
	out.println("<B>AUTH_TYPE</B> : "+request.getAuthType()+"<BR>");
	out.println("<B>REMOTE_USER</B> : "+request.getRemoteUser()+"<BR>");
	out.println("<B>CONTENT_TYPE</B> : "+request.getContentType()+"<BR>");
	out.println("<B>Character Encoding</B> : "+
		    request.getCharacterEncoding()+"<BR>");
	out.println("<B>CONTENT_LENGTH</B> : "+
		    request.getContentLength()+"<BR>");
	out.println("<B>HTTP_ACCEPT</B> : "+
		    request.getHeader("Accept")+"<BR>");
	out.println("<B>HTTP_USER_AGENT</B> : "+
		    request.getHeader("User-Agent")+"<BR>");
	out.println("<B>HTTP_REFERER</B> : "+
		    request.getHeader("Referer")+"<BR>");
        boolean secure = request.isSecure();
	if (secure) {
	    out.println("<B>The transcation is secure</B><BR>");
	}
        else {
	    out.println("<B>The transcation is NOT secure!!!</B><BR>");
	}

	// Retrive Header Fields
	out.println("<BR><BR>");
	out.println("<H1>Header Fields and Values</H1><BR>");
	Enumeration headerFields = request.getHeaderNames();
	String headerField = null;

	// Iterate over names and print values from the FORM
	out.println("<H1>Name and Value from the request HEADER</H1><BR>");
	while (headerFields.hasMoreElements() ) {
	    headerField = (String)headerFields.nextElement();
	    out.println("<B>" + headerField + "</B> : " +
			request.getHeader(headerField) + "<BR>");
	}

	// Retrive Attributes
	out.println("<BR><BR>");
	out.println("<H1>Attribute Names and Values</H1><BR>");
	Enumeration attributeNames = request.getAttributeNames();
	String attributeName = null;

	// Iterate over names and print values from the FORM
	out.println("<H1>Name and Value from Attribute List</H1><BR>");
        if(! attributeNames.hasMoreElements()) {
	    out.println("<B>No Attributes Defined</B></BR>");
	}
	while (attributeNames.hasMoreElements() ) {
	    attributeName = (String)attributeNames.nextElement();
	    out.println("<B>" + attributeName + "</B> : " +
			request.getAttribute(attributeName) + "<BR>");
	}


	out.println("</BODY>");
	out.println("</HTML>");

	out.close();
    }

    public String getServletInfo() {
	return "Servlet listing data from HTML form";
    }
}

