package test.ct;
/**
 * @(#) AdderBean.java
 * @author  Ken Flurchick
 * Date:    07/18/2000
 * Purpose: Bean for the adder application page of 
 *          the Problem Description Test Toolkit.
 *
 * Required Classes:
 *          WebFlow Package
 */
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import WebFlow.*;
import WebFlow.event.*;
import WebFlow.ContextManager.*;
import org.omg.CORBA.*;
import java.util.*;
import java.text.*;
/**
 * Class: AdderBean
 *<p>
 *This class will process the Adder form.
 *</p>
 *<pre>
 *The AdderBean process is
 *              P1.html 
 *               ||
 *               ||
 *               \/
 * Phandler.jsp <=> AdderBean
 *</pre>
 * @param  None
 * @return None
 * @throws None
 */
public class AdderBean{
  ServletOutputStream out;
  ContextManager cm;
  private String type; 
  private String operand1;
  private String operand2;
  private String fileName;

  String DocumentRoot = "/usr/local/apache_t3.1/htdocs/SciPortal/";
  String  WHERE = DocumentRoot + "WEB-INF/Data/Test";

  public AdderBean(){
    // Empty constructor.
  }

// Setter methods for the Bean.
  public void setType(String S){
    this.type = S;
  }
  public void setOperand1(String S){
    this.operand1 = S;
  }
  public void setOperand2(String S){
    this.operand2 = S;
  }
  public void setFileName(String S){
    this.fileName = S;
  }
// Getter methods for the Bean.
  public String getType(){
    return type;
  }
  public String getOperand1(){
    return operand1;
  }
  public String getOperand2(){
    return operand2;
  }
  public String getFileName(){
    return fileName;
  }
/**
 * Method: IF
 *<p>
 *Write the input file.
 *</p>
 * @param  None
 * @return boolean status
 * @throws None
 */
  public boolean IF() {
    String inputFile = null;
    boolean status = false;

    inputFile = WHERE + fileName;
    System.out.println("inputFile = " + inputFile);

    try{
      PrintWriter Out = new PrintWriter(
        new FileWriter(inputFile, false));

      // Output the data.
      Out.println(type);
      Out.println(operand1);
      Out.println(operand2);
      Out.close();
      status = true;
    } catch(IOException e){
      System.out.println("Error opening Out.");
      System.exit(0);
    }
    return status;
  }
/**
 * Method: getBeanInfo
 * @param  None
 * @return None
 * @throws None
 */
  public String getBeanInfo(){
    return "By K. Flurchick and T. Haupt";
  }
}
