import org.apache.xerces.dom.*;
import org.w3c.dom.*;
import org.apache.xml.serialize.*;
import java.io.*;
import java.util.*;

public class TestOutput
{

  Document  doc;
  Element rootElement;
 
  public TestOutput()
  {
    super();
  }

  public void createNewXMLFile(String docTypeName, 
                                      String DTDName,
                                      String XMLFileName)
  {
    DOMImplementation domImpl = new DOMImplementationImpl();
    DocumentType docType = null;
    try
    {
      docType = domImpl.createDocumentType(docTypeName, null, DTDName);
      doc = new DocumentImpl(docType);
      rootElement = doc.createElement(docTypeName);
      rootElement.setAttribute("name", "Program Generated");
      rootElement.setAttribute("author", "Program Generated");
      rootElement.setAttribute("date", new Date().toString());
      doc.appendChild( rootElement );
    } 
    catch(DOMException e)
    {
      System.out.println("createNewAddressBook error: " + e.toString() );
    }
      //System.out.println("createNewAddressBook Name " + 
      //    docType.getName() );
      //System.out.println("createNewAddressBook PublicId " + 
      //    docType.getPublicId() );
      //System.out.println("createNewAddressBook SystemId " + 
      //    docType.getSystemId() ); 

    File XMLFile = new File(XMLFileName);
    if(XMLFile != null)
    {
      XMLSerializer serializer = new XMLSerializer();
      try
      {
        serializer.setOutputCharStream(new FileWriter(XMLFile) );
        serializer.serialize(doc);
      }
      catch(IOException ioExcp)
      {
        System.out.println("Save failed: " + ioExcp.toString() );
      }
    }
  }

  public static void main(String[] args) throws Exception
  {
    TestOutput to = new TestOutput();
    to.createNewXMLFile("ROOT", "simple.dtd", "simple.xml");
  }

}
