/*
 * This example is from the book "Java Enterprise in a Nutshell".
 * Copyright (c) 1999 by O'Reilly & Associates.  
 * You may distribute this source code for non-commercial purposes only.
 * You may study, modify, and use this example for any purpose, as long as
 * this notice is retained.  Note that this example is provided "as is",
 * WITHOUT WARRANTY of any kind either expressed or implied.
 */

package stateless;

// Uncomment for use with standard EJB servers
import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;

// Uncomment for use with WebLogic, which has  its own RMI package names.
// import weblogic.rmi.RemoteException;
// import weblogic.rmi.server.UnicastRemoteObject;

import java.util.Properties;

public class ProfileImpl extends UnicastRemoteObject implements Profile {
  protected Properties mPEntries = new Properties();

  public ProfileImpl(String name) throws RemoteException {
    mPEntries.put("Name", name);
  }
  
  public String getProfileEntry(String name) throws RemoteException {
    return mPEntries.getProperty(name);
  }
  
  public void setProfileEntry(String name, String value)
    throws RemoteException {
    mPEntries.put(name, value);
  }
}
