/*
 * This example is from the book "Java Enterprise in a Nutshell".
 * Copyright (c) 1999 by O'Reilly & Associates.  
 * You may distribute this source code for non-commercial purposes only.
 * You may study, modify, and use this example for any purpose, as long as
 * this notice is retained.  Note that this example is provided "as is",
 * WITHOUT WARRANTY of any kind either expressed or implied.
 */

package stateless;

import NoSuchPersonException;
import javax.ejb.*;
import java.rmi.RemoteException;
import java.rmi.Remote;

/**
 * The remote interface for a ProfileServerBean, which provides enterprise
 * profile information for a named person.
 */
public interface ProfileServer extends EJBObject {
  public Profile getProfile(String name)
    throws NoSuchPersonException, RemoteException;
}
