/*
 * This example is from the book "Java Enterprise in a Nutshell".
 * Copyright (c) 1999 by O'Reilly & Associates.  
 * You may distribute this source code for non-commercial purposes only.
 * You may study, modify, and use this example for any purpose, as long as
 * this notice is retained.  Note that this example is provided "as is",
 * WITHOUT WARRANTY of any kind either expressed or implied.
 */

/******************************************************************************
help.java

The help command displays help for NamingShell. If the user types

    help [command]
    
help invokes that command's help method.
******************************************************************************/

import java.lang.reflect.Method;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

import javax.naming.Context;

public class help implements Command {
    public void execute(Context currentContext, Vector args) 
        throws CommandException {
        
        if (args.isEmpty())
            help();
        else {
            String commandName = (String)args.firstElement();
            Command command = NamingShell.loadCommand(commandName);
            if (command != null)
                command.help();
            else 
                throw new CommandException(new Exception(), 
                    "No help available for this command");
        }
    }
    
    public void help() { System.out.print("Usage: help [command]"); }
}
