/*
 * This example is from the book "Java Enterprise in a Nutshell".
 * Copyright (c) 1999 by O'Reilly & Associates.  
 * You may distribute this source code for non-commercial purposes only.
 * You may study, modify, and use this example for any purpose, as long as
 * this notice is retained.  Note that this example is provided "as is",
 * WITHOUT WARRANTY of any kind either expressed or implied.
 */

import java.rmi.registry.Registry;
import java.rmi.registry.LocateRegistry;

public class AccountManagerTest {
  public static void main(String argv[]) {
    try {
      String host = argv[0];
      String name = argv[1];
      Registry rmtReg = LocateRegistry.getRegistry(host);
      AccountManager mgr = (AccountManager)rmtReg.lookup(name);
      Account acct = mgr.getAccount("Fred");
      System.out.println("Got account, name = " + acct.getName());
      acct.deposit(1000);
      System.out.println("New account balance = " + acct.getBalance());
    }
    catch (Exception e) { e.printStackTrace(); }
  }
}
