/*
 * This example is from the book "Java Enterprise in a Nutshell".
 * Copyright (c) 1999 by O'Reilly & Associates.  
 * You may distribute this source code for non-commercial purposes only.
 * You may study, modify, and use this example for any purpose, as long as
 * this notice is retained.  Note that this example is provided "as is",
 * WITHOUT WARRANTY of any kind either expressed or implied.
 */

import java.rmi.Naming;
import java.rmi.RMISecurityManager;

public class ActivatableClient {
  public static void main(String argv[]) {
    String host = argv[0];
    String name = argv[1];
    try {
      // Set the RMI security manager, in case we need to load remote classes
      System.setSecurityManager(new RMISecurityManager());
      // Lookup activatable object
      ThisOrThatServer server =
        (ThisOrThatServer)Naming.lookup("rmi://" + host + "/" + name);
      System.out.println("Got server");
      System.out.println(server.doThis("something"));
    }
    catch (Exception e) {
      System.out.println("Error while looking up server:");
      e.printStackTrace();
    }
  }
}
