/**
 * @(#)parseRU.java
 * @author 	Ken Flurchick <kenf@osc.edu>
 * Date:	02/27/2000
 * Purpose:	Parse the registeredUser XML file
 *			using xml4j implementation of DOM.
 * @version 0.75 Removed the vector, pass  back only the hash table.
 * @version 0.01 Initial version.
 */
import com.ibm.xml.*;
import com.ibm.xml.parser.*;
import com.ibm.xml.parsers.*;
import java.io.*;
import java.util.*;
import java.text.*;
import org.w3c.dom.*;
import com.ibm.xml.framework.*;
/**
 * Class:	parseRU()
 * <p>
 * Methods
 * </p>
 *<ul TYPE="square">
 *	<li>doParse(String name)
 *		<br>- Parse the file named by <i>name</i>
 *	<li>makeChildrenText(Nodce node)
 *		<br>- Get the node and call the next method.
 *	<li>makeChildrenText1 (Node node, StringBuffer buffer)
 *		<br>- Get the text of the node.
 *</ul>
 * @param	None
 * @return	None
 * @throws	None
 */
public class parseRU {
	Vector nVec = new Vector(); // nVec is the key vector.
	Vector vVec = new Vector(); // vVec is the value vector.
	static String value = null;
	Hashtable tHash = new Hashtable();
	Hashtable hash = new Hashtable();
	Vector userKey = new Vector();
	Vector userValue = new Vector();
	int nUsers = 0;
	Element item, itemA, itemB;
/**
 * Constructor: parseFile
 * @param	None
 * @return	None
 * @throws	None
 */
	public void parseFile(){
		// Empty Constructor
	}
/**
 * Method: 	doParse
 * <ul type="square">
 *	<li>0 - OK
 *	<li>1 - Missing file name
 *	<li>2 - Parse errors
 * </ul>
 * <p>
 * Parse an XML file and return the hashtable of keys
 * and values.
 * </p>
 * @param	String name, String dtdFile, Hashtable hash
 * @return	integer
 * @throws	None
 */
	public int doParse(String name, String dtdFile, Hashtable hash){
		String key = null, value = null;
		String hName = null;
		String lup = null;
		nUsers = 0;

        if (name == null || dtdFile == null) {
            System.err.println("Missing filename.");
            return nUsers;
        }
        try {
            // Open XML file
            FileInputStream is = new FileInputStream(name);

            // Start parsing
            Parser parser = new Parser(name);

            // Check if there is errors
            if (parser.getNumberOfErrors() > 0) {
				System.out.println("Errors > zero");
                return(2);
            }
            // Document is well-formed

            Document doc = parser.readStream(is);
            Element r = doc.getDocumentElement();
            lup = r.getAttribute("lastUpdate");
            // System.out.println("doParse lup = " + lup);
            Vector aTags = getAllTags(r, "User");
			nUsers = aTags.size();
			removeWhiteSpaceNodes(r);

			NodeList nl0 = r.getChildNodes();
			buildNodes(nl0, hName);
        } catch (Exception e) {
            e.printStackTrace();
        }
		// Make the hash table from the name/value pairs.
		hash.put("lastUpdate", lup);
		for(int l = 0; l < nVec.size(); l++){
			hash.put(nVec.get(l), (vVec.get(l) + "::"));
		}
		// System.out.println("Hash Table = " + hash.toString());
		return nUsers;
	}
/**
 * Method: 	doParseF
 * <p>
 * Parse an XML file and return the hashtable of keys
 * and values for a specific user.
 * </p>
 * @param	String name, String dtdFile, Hashtable thash
 * @return	integer
 * @throws	None
 */
	public int doParseF(String name, String dtdFile, Hashtable tHash){
		nUsers = 0;
		String key = null, value = null, hName = null;

        if (name == null || dtdFile == null) {
            System.err.println("Missing filename.");
            return nUsers;
        }
        try {
            // Open XML file
            FileInputStream is = new FileInputStream(name);

            // Start parsing
            Parser parser = new Parser(name);

            // Check if there is errors
            if (parser.getNumberOfErrors() > 0) {
				System.out.println("Errors > zero");
                return(2);
            }
            // Document is well-formed

            Document doc = parser.readStream(is);
            Element r = doc.getDocumentElement();
			Vector aTags = getAllTags(r, "User");
			nUsers = aTags.size();
			removeWhiteSpaceNodes(r);

			NodeList nl0 = r.getChildNodes();
			buildNodes(nl0, hName);
        } catch (Exception e) {
            e.printStackTrace();
        }
		// Make the hash table from the name/value pairs.
		for(int l = 0; l < nVec.size(); l++){
			hash.put(nVec.get(l), (vVec.get(l) + "::"));
		}
		// System.out.println("Hash Table = " + hash.toString());

		// Make the tHash table (assembled by User ID rather
		// than by keywords) from the name/value pairs.
		// Zeroth element is the number of users.
		keyVector();
		// System.out.println("nUsers = " + nUsers);
		for(int k = 0; k < userKey.size(); k++){
			int startIndex = 0;
			for(int l = 0; l < nUsers; l++){
				if(k == 0){
					String tt = (String)hash.get(userKey.get(k));
					userValue.add(l, tt.substring(startIndex,
						tt.indexOf("::", startIndex)) + "::");
					startIndex = tt.indexOf("::", startIndex) + 2;
				} else {
					String tt = (String)hash.get(userKey.get(k));
					userValue.set(l, (String)userValue.elementAt(l)
						+ tt.substring(startIndex,
						tt.indexOf("::", startIndex)) + "::");
					startIndex = tt.indexOf("::", startIndex) + 2;
				}
			}
		}
		for(int l = 0; l < nUsers; l++){
			String XX = (String)userValue.get(l);
			tHash.put(XX.substring(0, XX.indexOf("::")), XX);
		}
		// System.out.println("tHash Table = " + tHash.toString());

		return nUsers;
	}
/**
 * Method: 	removeUser()
 * <p>
 * Remove the specified user uidF.
 * </p>
 * @param	String name, String dtdFile, String uidF
 * @return	boolean status
 * @throws	None
 */
    public boolean removeUser(String name, String dtdFile, String uidF) {
		String hName = null;
		boolean status = false;
		Document doc = new TXDocument();
		// Document doc = new Document();
        try {
			String f1 = "MM  dd  yyyy  hh  mm";
			String f2 = "MM/dd/yyyy  hh:mm";
			SimpleDateFormat in = new SimpleDateFormat(f1);
			SimpleDateFormat out = new SimpleDateFormat(f2);

			Calendar cal = Calendar.getInstance();
			String datestring = (
				cal.get(Calendar.MONTH) + 1) + "  "
					+ cal.get(Calendar.DAY_OF_MONTH) + "  "
					+ cal.get(Calendar.YEAR) + "  "
					+ cal.get(Calendar.HOUR) + "  "
					+ cal.get(Calendar.MINUTE);
			Date curr = in.parse(datestring);

            // Open XML file
            FileInputStream is = new FileInputStream(name);

            // Start parsing
            Parser parser = new Parser(name);

            // Check if there is errors
            if (parser.getNumberOfErrors() > 0) {
				System.out.println("Errors > zero");
				status = false;
                return status;
            }
            // Document is well-formed

            doc = parser.readStream(is);
            Element r = doc.getDocumentElement();
            r.setAttribute("lastUpdate", out.format(curr));
			removeWhiteSpaceNodes(r);

			NodeList nl0 = r.getChildNodes();
			buildNodes(nl0, hName);

			Vector aTags = getAllTags(r, "User");
			int m = aTags.size();
			for (int j = 0; j < m; j++) {
				Node a = (Node)aTags.elementAt(j);
				if( ((Element)a).getAttribute("UID").equals(uidF)) {
					r.removeChild(a);
					status = true;
				}
			}
		} catch (Exception e) {
			System.out.println(e+" while removing user" );
 			status = false;
		}
		// Save the XML document
		// System.out.println("ruFile = " + name);
		try{
			PrintWriter ruFileOut = new PrintWriter(
				new FileWriter(name, false));
			((TXDocument)doc).printWithFormat(ruFileOut);
		} catch(IOException e){
			System.out.println("Error opening ruFileOut.");
			System.exit(0);
		}
		return status;
	}
/**
 * Method: 	addUser
 * <p>
 * Add the new User node.
 * </p>
 * @param	String name, String dtdFile, Hastable uData
 * @return	boolean status
 * @throws	None
 */
    public boolean addUser(String name, String dtdFile, Hashtable uData) {
		String hName = null;
		boolean status = false;
		Document doc = new TXDocument();
		// Document doc = new Document();
        try {
			String f1 = "MM  dd  yyyy  hh  mm";
			String f2 = "MM/dd/yyyy  hh:mm";
			SimpleDateFormat in = new SimpleDateFormat(f1);
			SimpleDateFormat out = new SimpleDateFormat(f2);

			Calendar cal = Calendar.getInstance();
			String datestring = (
				cal.get(Calendar.MONTH) + 1) + "  "
					+ cal.get(Calendar.DAY_OF_MONTH) + "  "
					+ cal.get(Calendar.YEAR) + "  "
					+ cal.get(Calendar.HOUR) + "  "
					+ cal.get(Calendar.MINUTE);
			Date curr = in.parse(datestring);

            // Open XML file
            FileInputStream is = new FileInputStream(name);

            // Start parsing
            Parser parser = new Parser(name);

            // Check if there is errors
            if (parser.getNumberOfErrors() > 0) {
				System.out.println("Errors > zero");
				status = false;
                return status;
            }
            // Document is well-formed

            doc = parser.readStream(is);
            Element r = doc.getDocumentElement();
            r.setAttribute("lastUpdate", out.format(curr));
			removeWhiteSpaceNodes(r);

			NodeList nl0 = r.getChildNodes();
			buildNodes(nl0, hName);


			//  Make <User> element and add it
			//  as a child of root
			item = doc.createElement("User");
			item.setAttribute("UID",
				(String)uData.get("userID"));

			// Make <userID> element and add it
			// as a child of User
			itemA = doc.createElement("userID");
			itemA.appendChild(doc.createTextNode(
				(String)uData.get("userID")));
			item.appendChild(itemA);

			// Make <primaryArea> element and add it
			// as a child of User
			itemA = doc.createElement("primaryArea");
			itemA.appendChild(doc.createTextNode(
				(String)uData.get("primaryArea")));
			item.appendChild(itemA);

			// Make <projectNumber> element and add it
			// as a child of User
			itemA = doc.createElement("projectNumber");
			itemA.appendChild(doc.createTextNode(
				(String)uData.get("projectNumber")));
			item.appendChild(itemA);

			// Make <email> element and add it
			// as a child of User
			itemA = doc.createElement("email");
			itemA.appendChild(doc.createTextNode(
				(String)uData.get("email")));
			item.appendChild(itemA);

			//  Make <organization> element and add it
			//  as a child of User
			itemA = doc.createElement("organization");
			itemA.appendChild(doc.createTextNode(
				(String)uData.get("organization")));
			item.appendChild(itemA);

			//  Make <Person> element and add it
			//  as a child of User
			itemA = doc.createElement("Person");

			//  Make <title> element and add it
			//  as a child of Person
			itemB = doc.createElement("title");
			itemB.appendChild(doc.createTextNode(
				(String)uData.get("title")));
			itemA.appendChild(itemB);

			//  Make <lastName> element and add it
			//  as a child of Person
			itemB = doc.createElement("lastName");
			itemB.appendChild(doc.createTextNode(
				(String)uData.get("lastName")));
			itemA.appendChild(itemB);

			//  Make <firstName> element and add it
			//  as a child of Person
			itemB = doc.createElement("firstName");
			itemB.appendChild(doc.createTextNode(
				(String)uData.get("firstName")));
			itemA.appendChild(itemB);

			//  Make <middleName> element and add it
			//  as a child of Person
			itemB = doc.createElement("middleName");
			itemB.appendChild(doc.createTextNode(
				(String)uData.get("middleName")));
			itemA.appendChild(itemB);

			//  Add <Person> as a child of <user>
			item.appendChild(itemA);

			//  Make <Address> element and add it
			//  as a child of User
			itemA = doc.createElement("Address");

			//  Make <street1> element and add it
			//  as a child of Address
			itemB = doc.createElement("street1");
			itemB.appendChild(doc.createTextNode(
				(String)uData.get("street1")));
			itemA.appendChild(itemB);

			//  Make <street2> element and add it
			//  as a child of Address
			itemB = doc.createElement("street2");
			itemB.appendChild(doc.createTextNode(
				(String)uData.get("street2")));
			itemA.appendChild(itemB);

			//  Make <mailStop> element and add it
			//  as a child of Address
			itemB = doc.createElement("mailStop");
			itemB.appendChild(doc.createTextNode(
				(String)uData.get("mailStop")));
			itemA.appendChild(itemB);

			//  Make <building> element and add it
			//  as a child of Address
			itemB = doc.createElement("building");
			itemB.appendChild(doc.createTextNode(
				(String)uData.get("building")));
			itemA.appendChild(itemB);

			//  Make <city> element and add it
			//  as a child of Address
			itemB = doc.createElement("city");
			itemB.appendChild(doc.createTextNode(
				(String)uData.get("city")));
			itemA.appendChild(itemB);

			//  Make <state> element and add it
			//  as a child of Address
			itemB = doc.createElement("state");
			itemB.appendChild(doc.createTextNode(
				(String)uData.get("state")));
			itemA.appendChild(itemB);

			//  Make <zipcode> element and add it
			//  as a child of Address
			itemB = doc.createElement("zipcode");
			itemB.appendChild(doc.createTextNode(
				(String)uData.get("zipcode")));
			itemA.appendChild(itemB);

			//  Make <zip4> element and add it
			//  as a child of Address
			itemB = doc.createElement("zip4");
			itemB.appendChild(doc.createTextNode(
				(String)uData.get("zip4")));
			itemA.appendChild(itemB);

			//  Add <Address> as a child of <user>
			item.appendChild(itemA);

			//  Make <contact> element and add it
			//  as a child of User
			itemA = doc.createElement("contact");

			//  Make <officePhone> element and add it
			//  as a child of contact
			itemB = doc.createElement("officePhone");
			itemB.appendChild(doc.createTextNode(
				(String)uData.get("officePhone")));
			itemA.appendChild(itemB);

			//  Make <faxNumber> element and add it
			//  as a child of contact
			itemB = doc.createElement("faxNumber");
			itemB.appendChild(doc.createTextNode(
				(String)uData.get("faxNumber")));
			itemA.appendChild(itemB);

			//  Add <contact> as a child of <user>
			item.appendChild(itemA);

			//  Add <contact> as a child of <user>
			r.insertBefore((Node)item, null);
		} catch (Exception e) {
			System.out.println(e+" while removing user" );
 			status = false;
		}
		// Save the XML document
		// System.out.println("ruFile = " + name);
		try{
			PrintWriter ruFileOut = new PrintWriter(
				new FileWriter(name, false));
			((TXDocument)doc).printWithFormat(ruFileOut);
		} catch(IOException e){
			System.out.println("Error opening ruFileOut.");
			System.exit(0);
		}
		return status;
	}
/**
 * Method: 	removeWhiteSpaceNodes
 * <p>
 * Remove the white space associated with a node.
 * </p>
 * @param	Element parent
 * @return	None
 * @throws	None
 */
    public void removeWhiteSpaceNodes(Element parent) {
		Node nextNode = parent.getFirstChild();
        for (Node child = parent.getFirstChild();
				nextNode != null;) {
			child = nextNode;
			nextNode = child.getNextSibling();

            if (child instanceof TXText){
				if(((TXText)child).getIsIgnorableWhitespace()){
					parent.removeChild(child);
				}
            } else if(child instanceof TXElement){
				removeWhiteSpaceNodes((Element)child);
			}
		}
    }
/**
 * Method: 	buildNodes
 * <p>
 * Parse a node and return the name/value pairs
 * as two vectors:
 * </p>
 * <ol>
 *	<li>nVec - vector of keys.
 *	<li>vVec - vector of values
 * </ol>
 * @param	NodeList nl, String hName
 * @return	None
 * @throws	None
 */
    public void buildNodes(NodeList nl, String hName){
		int inl = 0;
		int inl2 = 0;
		int l;
		boolean found = false;

		while(inl < (nl.getLength())){
			Node childNL = nl.item(inl);
			String chName = childNL.getNodeName();
			if(chName != "#text") {
				hName = chName;
			}
			String chValue = childNL.getNodeValue();
			if (childNL instanceof TXText) {
				chValue = childNL.getNodeValue();
			} else if (childNL.hasChildNodes()){
				NodeList nl2 = childNL.getChildNodes();
				buildNodes(nl2, hName);
			}
			inl++;
			if((hName != null) && (chValue != null)) {
				if(nVec.isEmpty() == true){
					nVec.addElement(hName);
					vVec.addElement(chValue);
					found = false;
				} else if(nVec.isEmpty() != true){
					for(l = 0; l < nVec.size(); l++){
						if (hName.equals(nVec.get(l))){
							found = true;
							value = (String)vVec.get(l);
							value = value + "::" + chValue;
							vVec.setElementAt(value, l);
							break;
						}
					}
					if(found == false) {
						nVec.addElement(hName);
						vVec.addElement(chValue);
						found = false;
					}
				}
			}
		}
	}
/**
 * Method: 	keyVector
 * <p>
 * Generate a vector of the list of tags.
 * </p>
 * @param	None
 * @return	None
 * @throws	None
 */
	void keyVector(){
		userKey.add("userID");
		userKey.add("primaryArea");
		userKey.add("projectNumber");
		userKey.add("email");
		userKey.add("organization");
		userKey.add("title");
		userKey.add("lastName");
		userKey.add("firstName");
		userKey.add("middleName");
		userKey.add("street1");
		userKey.add("street2");
		userKey.add("mailStop");
		userKey.add("building");
		userKey.add("city");
		userKey.add("state");
		userKey.add("zipcode");
		userKey.add("zip4");
		userKey.add("officePhone");
		userKey.add("faxNumber");
	}
/**
 * Method: 	getAlltags
 * <p>
 * Gett a Vector of nodes that have a specific node name.
 * </p>
 * @param	Node node, String tag
 * @return	Vector result
 * @throws	None
 */
	private Vector getAllTags(Node node, String tag) {
		Vector result=new Vector();

		for(Node ch = node.getFirstChild(); ch!=null;
				ch = ch.getNextSibling()) {
			if(ch instanceof Element) {
				if(ch.getNodeName().equals(tag)) {
					result.addElement(ch);
				}
			}
		}
		return result;
	}
}
